	SUBROUTINE BANDS
****************************************************************
*   Control module for package of programs solved generalized  *
*         eigenvalue problem of the LMTO method                *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	COMMON /KAPPAR/ NPAN
	COMMON /SPIN/   NSPIN
        COMMON /OUT1/   ICCON,ICFTR,ICKOV,ICPSI,ICTMP,ICBND
	COMMON /MESH/   NPNT
	COMMON /UNIT/   IUN
C ****** COMPUTE EIGENVALUES AND EIGENVECTORS ************
	DO IPAN=1,NPAN           !!! over panels
        CALL SNULTOS(IPAN)       !!! set tos-matrix to zero
	CALL SSETENY(IPAN)       !!! place Eny somewhere
	CALL SCORENY(IPAN)       !!! find binding energies for semicore
	CALL SPOTPAR(IPAN)       !!! different potential partameters
	CALL SKKRPAR(IPAN)       !!! KKR-partameters (only to print)
	CALL SPRIPAR(IPAN)       !!! print potential parameters
	CALL SLMTPAR(IPAN)       !!! some combinations of parameters
	CALL SOVRPAR(IPAN)       !!! potential parameters for overlapping
	CALL SNMTPAR(IPAN)       !!! NMT potential parameters
	CALL SINTPAR(IPAN)       !!! INT potential parameters
	CALL SHUBPAR(IPAN)       !!! Hubbard corrections
	CALL SORBPAR(IPAN)       !!! SO-coupling parameters
	DO IPNT=1,NPNT           !!! over k-points
	IF(ICBND.NE.2.OR.ICPSI.NE.2)THEN
	CALL INTMAT(IPNT,IPAN)   !!! pseudopotential matrix elements
	CALL STRGNT(IPNT,IPAN)   !!! restore bare structure matrices
	CALL LMTMAT(IPNT,IPAN)   !!! hamiltonian and overlap from MTS
	CALL ORBMAT(IPNT,IPAN)   !!! SO-coupling to the hamiltonian
	CALL LMTBND(IPNT,IPAN)   !!! solve eigenvalue problem
	ENDIF
        CALL TOSPAR(IPNT,IPAN,0) !!! BZ-integrals from the occupied states
	ENDDO                    !!! over k-points
	CLOSE(13,STATUS='DELETE')!!! close scratch file opened in NMTPAR
	CLOSE(18,STATUS='DELETE')!!! close scratch file opened in INTPAR
	ENDDO                    !!! over panels
	CLOSE(10,STATUS='KEEP')  !!! close BNDFILE opened in LMTPAR
	CLOSE(15,STATUS='KEEP')  !!! close PSIFILE opened in LMTPAR
	END
