	SUBROUTINE DELBEXCH(IGPTB,MY,IQPNT,KEY)
******************************************************
*  Calculates exchange-correlation magnetic field.   *
******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NTHEMAX=4*LMAXV+6)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NRAD(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &   ,NCUT(NSORTMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DPOT(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DBXC(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,ROTOT(NSPINMAX),DIM,RHOL,DMGTOT(NSPINMAX)
     &   ,YLM(LMMAXV),YLMI(LMMAXV)
	COMPLEX*16 FUN(0:NRADMAX,LMMAXV),DRODR(0:NRADMAX,NSPINMAX,2)
     &   ,G1RO(0:NRADMAX,LMMAXV,NSPINMAX,NGGAMAX)
     &   ,G2RO(0:NRADMAX,LMMAXV,NSPINMAX,NGGAMAX,NGGAMAX)
     &   ,GR1UP(-1:1),GR2UP(-1:1,-1:1),G1TOT(NSPINMAX,-1:1)
     &   ,GR1DN(-1:1),GR2DN(-1:1,-1:1),G2TOT(NSPINMAX,-1:1,-1:1)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,SMT(NSORTMAX),RL(0:NRADMAX,0:LMAXV,NSORTMAX)
     &   ,Z(NSORTMAX),ZCOR(NSORTMAX)
     &   ,ZL(NTHEMAX,2),WL(NTHEMAX,2)
	LOGICAL SYM(LMMAXV,NPAT)
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
	COMMON /ORBS/   NORBS                               !!! from readini
	COMMON /EXCH/   IXC                                 !!! from readini
C Inputs:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
	COMMON /MULTRO/ Z,ZCOR                              !!! from readini
	COMMON /SYMMLM/ SYM,LMSYM        		    !!! from sym
C Density:
	COMMON /DENS/   RO                                  !!! from readscf
        COMMON /STORE1/ G2RO                                !!! tmp.storage
        COMMON /STORE3/ FUN,G1RO                            !!! tmp.storage
	COMMON /DELRO/  DRHO,DMAG                           !!! from delrho
C Potential:
	COMMON /DELPOT/ DPOT,DBXC                           !!! from delpot
C Radial mesh:
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from radmesh
	COMMON /UNIT/   IUN                                 !!! from readini
	DATA PI/3.141592653589793D0/
        IF(NORBS.EQ.1.AND.(MY.EQ.0.OR.MY.EQ.2))RETURN
	SQPI4=2.D0*SQRT(PI)
        SFACT=0.5D0*DBLE(NSPIN)
C Set keys for LDA and GGA
        ILDA=MOD(IXC,10)     !!! LDA key
        IGGA=(IXC-ILDA)/10   !!! GGA key
C START LOOPING OVER ALL ATOMS IN CELL
        DO 1000 IATOM=1,NATOM               !!! over all atoms in cell
        ISORT=IS(IATOM)
C Set gradients to zero
        DO NY=-1,1
        GR1UP(NY)=(0.D0,0.D0)
        GR1DN(NY)=(0.D0,0.D0)
        DO NY1=-1,1
        GR2UP(NY,NY1)=(0.D0,0.D0)
        GR2DN(NY,NY1)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ALRUP=0.D0
        ALRDN=0.D0
C **** COMPUTE DENSITY GRADIENTS FOR GGA ****
C Compute spherical density gradients
        DO ISPIN=1,NSPIN
        CALL CDERIV1(RO(0,1,IATOM,ISPIN),DRODR(0,ISPIN,1),
     &  NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),SMT(ISORT))
        CALL CDERIV1(DRODR(0,ISPIN,1),DRODR(0,ISPIN,2),
     &  NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),SMT(ISORT))
        ENDDO
C Full density gradients and gradients of the deltaRHO.
        IF(IGGA.NE.0)THEN
        DO ISPIN=1,NSPIN                    !!! over spins
        DO L=0,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        ISYM=LMSYM(LM,IATOM)
        DO IRAD=0,NRAD(ISORT)
        FUN(IRAD,LM)=(0.D0,0.D0)
        IF(SYM(LM,IATOM))
     &  FUN(IRAD,LM)=RO(IRAD,ISYM,IATOM,ISPIN)
        ENDDO
        ENDDO
        ENDDO
        DO NY=-1,1                          !!! over directions
C Nabla_mu(Rho)
        CALL GRADFUN(FUN(0,1),G1RO(0,1,ISPIN,NY+2),NY,ILSV(ISORT),
     &  NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),SMT(ISORT))
        DO NY1=-1,1                         !!! over directions
C Nabla_mu*Nabla_mu'(Rho)
        CALL GRADFUN( G1RO(0,1,ISPIN,NY+2), G2RO(0,1,ISPIN,NY+2,NY1+2),
     &  NY1,ILSV(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),
     &  DR(0,ISORT),SMT(ISORT))
        ENDDO                               !!! over directions
        ENDDO                               !!! over directions
        ENDDO                               !!! over spins
        ENDIF
C ***** CALCULATE EXCHANGE-CORRELATION USING TEILOR SERIES *****
        IF(ABS(Z(ISORT)).GE.1.D-05)RCUT1=0.03D0*Z(ISORT)**(1.D0/3.D0)
        IF(ABS(Z(ISORT)).LE.1.D-05)RCUT1=0.D0
        IF(RCUT1.GT.SMT(ISORT))STOP'<VEXCH>:RCUT>SMT NOT ASSUMED'
        NCUT(ISORT)=0
        DO IRAD=0,NRAD(ISORT)
        IF(R(IRAD,ISORT).LT.RCUT1)NCUT(ISORT)=IRAD
        ENDDO
        DO 100 IRAD=0,NCUT(ISORT)           !!! over irad
C Spherical Spin densities
        ROUP=DREAL(RO(IRAD,1,IATOM,1    ))/SQPI4*SFACT
        RODN=DREAL(RO(IRAD,1,IATOM,NSPIN))/SQPI4*SFACT
C Gradients from spherical densities, let x=y=z=r/sqrt(3)
        IF(IGGA.NE.0)THEN
        ALRUP=0.D0
        ALRDN=0.D0
        DO IA=-1,1
        GR1UP(IA)=DRODR(IRAD,1    ,1)/SQRT(3.D0)/SQPI4*SFACT
        GR1DN(IA)=DRODR(IRAD,NSPIN,1)/SQRT(3.D0)/SQPI4*SFACT
        DO IA1=-1,1
        IF(IA.EQ.IA1)SD=+2.D0
        IF(IA.NE.IA1)SD=-1.D0
        IF(IRAD.EQ.0)RR=R(1,ISORT)
        IF(IRAD.NE.0)RR=R(IRAD,ISORT)
        GR2UP(IA,IA1)=(DRODR(IRAD,1,    1)/RR*SD+
     &  DRODR(IRAD,1    ,2))/3.D0/SQPI4*SFACT
        GR2DN(IA,IA1)=(DRODR(IRAD,NSPIN,1)/RR*SD+
     &  DRODR(IRAD,NSPIN,2))/3.D0/SQPI4*SFACT
        ENDDO
        ALRUP=ALRUP+GR2UP(IA,IA)
        ALRDN=ALRDN+GR2DN(IA,IA)
        ENDDO
        ENDIF
C SET EXCHANGE-CORRELATION
        CALL EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &       IXC,KEY,NSPIN,EXCUP,EXCDN,VXCUP,VXCDN)
        IF(ABS(ROUP-RODN).LE.1.D-05)WXC=0.D0
        IF(ABS(ROUP-RODN).GT.1.D-05.AND.KEY.EQ.1)
     &  WXC=0.5D0*(VXCUP-VXCDN)/(ROUP-RODN)
        IF(ABS(ROUP-RODN).GT.1.D-05.AND.KEY.EQ.2)
     &  WXC=0.5D0*(VXCUP-VXCDN)
        DO ITRAN=1,NSPIN                    !!! over -/+ polarizations
        IF(ITRAN.EQ.1)JTRAN=NSPIN
        IF(ITRAN.EQ.NSPIN)JTRAN=1
        DO L=0,ILSV(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        DBXC(IRAD,LM,IATOM,ITRAN)=DBXC(IRAD,LM,IATOM,ITRAN)-
     &  DMAG(IRAD,LM,IATOM,JTRAN)*WXC
        ENDDO                               !!! over m
        ENDDO                               !!! over l
	ENDDO                               !!! over -/+ polarizations
 100	CONTINUE                            !!! over irad
C  **** CALCULATE EXCHANGE-CORRELATION BY DIRECT EXPANSION ****
        IF(ABS(Z(ISORT)).GE.1.D-05)RCUT2=0.3D0*Z(ISORT)**(1.D0/3.D0)
        IF(ABS(Z(ISORT)).LE.1.D-05)RCUT2=0.0D0
        NTHETA=2*ILSV(ISORT)+3
        IF(IGGA.EQ.0)NTWO=1 ! do not increase mesh in LDA
        IF(IGGA.NE.0)NTWO=2 ! increase mesh twice for GGA
        CALL MKLEGW(     NTHETA,ZL(1,1),WL(1,1),0)
        CALL MKLEGW(NTWO*NTHETA,ZL(1,2),WL(1,2),0)
        DO 400 IRAD=NCUT(ISORT)+1,NRAD(ISORT)!! over radial mesh
        IF(R(IRAD,ISORT).LE.RCUT2)MTWO=1
        IF(R(IRAD,ISORT).GT.RCUT2)MTWO=NTWO
        DO 300 ITHETA=1,NTHETA*MTWO         !!! over theta
        NPHI=NTHETA*MTWO
        ZCOORD=ZL(ITHETA,MTWO)
        STHETA=SQRT(1.D0-ZCOORD*ZCOORD)
        DPHI=2.D0*PI/DBLE(NPHI)
        WGTL=DPHI*WL(ITHETA,MTWO)
        DO 200 IPHI=1,NPHI                  !!! over phi
        PHI=DBLE(IPHI-1)*DPHI
        XCOORD=COS(PHI)*STHETA
        YCOORD=SIN(PHI)*STHETA
        CALL SPHHARM(XCOORD,YCOORD,ZCOORD,ILSV(ISORT),YLM)
        DIM=(0.D0,-1.D0)
        DO L=0,ILSV(ISORT)
        DIM=DIM*(0.D0,1.D0)
        DO M=-L,L
        LM=L*(L+1)+M+1
        YLMI(LM)=YLM(LM)*DIM
        ENDDO
        ENDDO
C  SET UP TOTAL DENSITY AT THE POINT "R,THETA,PHI"
        DO ISPIN=1,NSPIN                    !!! over spins
        ROTOT(ISPIN)=(0.D0,0.D0)
        DO L=0,ILSV(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        IF(SYM(LM,IATOM))THEN
        ISYM=LMSYM(LM,IATOM)
        ROTOT(ISPIN)=ROTOT(ISPIN)+RO(IRAD,ISYM,IATOM,ISPIN)*
     &  YLMI(LM)
        ENDIF
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over spins
C  SET UP CHANGE IN THE TOTAL DENSITY AT THE POINT "R,THETA,PHI"
	DO ITRAN=1,NSPIN                    !!! over spins
	DMGTOT(ITRAN)=(0.D0,0.D0)
	DO L=0,ILSV(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	DMGTOT(ITRAN)=DMGTOT(ITRAN)+DMAG(IRAD,LM,IATOM,ITRAN)*
     &  YLMI(LM)
	ENDDO                               !!! over m 
        ENDDO                               !!! over l
        ENDDO                               !!! over spins
C  SET UP DENSITY GRADIENTS AT THE POINT "R,THETA,PHI"
        IF(IGGA.NE.0)THEN
        DO NY=-1,1                          !!! over directions
        DO ISPIN=1,NSPIN                    !!! over spins
        G1TOT(ISPIN,NY)=(0.D0,0.D0)
	DO NY1=-1,1
        G2TOT(ISPIN,NY,NY1)=(0.D0,0.D0)
	ENDDO
        DO L=0,ILSV(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        G1TOT(ISPIN,NY)=G1TOT(ISPIN,NY)+
     &  YLMI(LM)*G1RO(IRAD,LM,ISPIN,NY+2)
	DO NY1=-1,1                         !!! over ny1
        G2TOT(ISPIN,NY,NY1)=G2TOT(ISPIN,NY,NY1)+
     &  YLMI(LM)*G2RO(IRAD,LM,ISPIN,NY+2,NY1+2)
	ENDDO                               !!! over ny1
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over spins
        ENDDO                               !!! over directions
        ENDIF
C  FIND EXCHANGE-CORRELATION CONTRIBUTION FROM "R,THETA,PHI"
C  Spin densities
        ROUP=DREAL(ROTOT(1    ))*SFACT
        RODN=DREAL(ROTOT(NSPIN))*SFACT
C  Spin gradients
        IF(IGGA.NE.0)THEN
        ALRUP=0.D0
        ALRDN=0.D0
        DO NY=-1,1
        GR1UP(NY)=G1TOT(1    ,NY)*SFACT
        GR1DN(NY)=G1TOT(NSPIN,NY)*SFACT
        DO NY1=-1,1
        GR2UP(NY,NY1)=G2TOT(1    ,NY,NY1)*SFACT
        GR2DN(NY,NY1)=G2TOT(NSPIN,NY,NY1)*SFACT
        ENDDO
        ALRUP=ALRUP+(-1)**NY*GR2UP(NY,-NY)
        ALRDN=ALRDN+(-1)**NY*GR2DN(NY,-NY)
        ENDDO
        ENDIF
        CALL EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &       IXC,KEY,NSPIN,EXCUP,EXCDN,VXCUP,VXCDN)
        IF(ABS(ROUP-RODN).LE.1.D-05)WXC=0.D0
        IF(ABS(ROUP-RODN).GT.1.D-05.AND.KEY.EQ.1)
     &  WXC=0.5D0*(VXCUP-VXCDN)/(ROUP-RODN)
        IF(ABS(ROUP-RODN).GT.1.D-05.AND.KEY.EQ.2)
     &  WXC=0.5D0*(VXCUP-VXCDN)
C  PROJECT ONTO SPHERICAL HARMONICS
        DO ITRAN=1,NSPIN                    !!! over -/+ polarizations
        IF(ITRAN.EQ.1)JTRAN=NSPIN
        IF(ITRAN.EQ.NSPIN)JTRAN=1
	RHOL=DMGTOT(JTRAN)*WXC*WGTL
	DO L=0,ILSV(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
        DBXC(IRAD,LM,IATOM,ITRAN)=DBXC(IRAD,LM,IATOM,ITRAN)-
     &  DCONJG(YLMI(LM))*RHOL
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over -/+ polarizations
 200    CONTINUE                            !!! over phi
 300	CONTINUE                            !!! over theta
 400	CONTINUE                            !!! over radial points
1000    CONTINUE                            !!! over atoms
	END
