	SUBROUTINE DELVHUBB(IGPTB,MY,IQPNT)
**********************************************************
*  Computes Hubbard correction to the LDA potential in   *
*  the LDA+U scheme.                                     *
*  The important parameter is ISCHM=0,11,12,13,...       *
*  in COMMON/HUBDAT/. See formulae below for a           *
*  particular scheme.                                    *
*  Last revised 16.01.99                                 *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &   ,NKAP(NPANMAX),IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,MCRL(NPAT),LCRL(0:LMAXB,NPAT)
	DIMENSION SMT(NSORTMAX)
     &   ,UMAT(LIMLMB2,LIMLMB2),GMAT(LIMLMB2,LIMLMB2)
     &   ,UBAR(0:LMAXB,0:LMAXB),GBAR(0:LMAXB,0:LMAXB)
	COMPLEX*16 
     &    VCNS(LIMLMB2,NPAT,NSPINMAX),VHUB(LIMLMB2,NPAT,NSPINMAX)
     &   ,DHUB(LIMLMB2,NPAT,NSPINMAX),DLDA(LIMLMB2,NPAT,NSPINMAX)
     &   ,DBAR(0:LMAXB,NPAT,NSPINMAX),DAVR(LIMLMB2,NPAT)
     &   ,DELVHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELBHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELDHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELVCNS(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELBCNS(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELDLDA(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
	LOGICAL LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
	CHARACTER*10 TXTEL(NSORTMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from readini
	COMMON /POTCOM/ SWZ,SMT                              !!! from vfull
	COMMON /KAPPAR/ NPAN,NKAP                            !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
	COMMON /STORE1/ UMAT,GMAT,UBAR,GBAR                  !!! from ttrint
	COMMON /HUBCOM/ DHUB,VHUB,DLDA,VCNS                  !!! from hubpot
        COMMON /HUBDAT/ NHUB,MCRL,LCRL,ISCHM                 !!! from readhub
        COMMON /DELHUB/ DELDHUB,DELMHUB,DELVHUB,DELBHUB
     &                 ,DELDLDA,DELVCNS,DELBCNS
	COMMON /SPIN/   NSPIN                                !!! from readini
        COMMON /ORBS/   NORBS                                !!! from readini
        COMMON /INP1/   ICHUB                                !!! from readini
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /TXTEL/  TXTEL                                !!! from readini
	DATA PI/3.141592653589793D0/
	IF(ICHUB.EQ.0)RETURN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)RETURN
C  DO GLOBALLY OVER ATOMS
	DO 1000 IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	CALL HUBMAT(IATOM) !!! set Hubbard and Exchange matrices
C  SET AVERAGE OCCUPANCIES <Nup> and <Ndn>
	DO ISPIN=1,NSPIN                          !!! over spins
	DO L=0,ILSB(ISORT)                        !!! over l
	DBAR(L,IATOM,ISPIN)=(0.D0,0.D0)
	DO M=-L,L                                 !!! over m
	LM=L*(L+1)+M+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M+1           !  (l,m m) packed
	DBAR(L,IATOM,ISPIN)=DBAR(L,IATOM,ISPIN)+
     &  DELDHUB(IU,IATOM,ISPIN,IGPTB,MY)
	ENDDO                                     !!! over m
	ENDDO                                     !!! over l
	ENDDO                                     !!! over spins
C  SET AVERAGE OVER SPINS ONLY
	DO L=0,ILSB(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	DO K=-L,L                                 !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
        DAVR(IU,IATOM)=(DELDHUB(IU,IATOM,1,IGPTB,MY)+
     &  DELDHUB(IU,IATOM,NSPIN,IGPTB,MY))/2.D0
	ENDDO                                     !!! over m
	ENDDO                                     !!! over k
	ENDDO                                     !!! over l
C  SET HUBBARD CORRECTION TO THE POTENTIAL
	DO ISPIN=1,NSPIN                          !!! over spins
	IF(ISPIN.EQ.1)ISPIN1=NSPIN
	IF(ISPIN.EQ.NSPIN)ISPIN1=1
	DO L=0,ILSB(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	DO K=-L,L                                 !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)=(0.D0,0.D0)
	DELVCNS(IU,IATOM,ISPIN,IGPTB,MY)=(0.D0,0.D0)
	DELDLDA(IU,IATOM,ISPIN,IGPTB,MY)=(0.D0,0.D0)
	DO L1=0,ILSB(ISORT)                       !!! over l1
	DO M1=-L1,L1                              !!! over m1
	DO K1=-L1,L1                              !!! over k1
	L1M1=L1*(L1+1)+M1+1
	L1K1=L1*(L1+1)+K1+1
	IU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+K1)+L1+M1+1  !  (l1,m1 k1) packed
	IF(ISCHM.EQ.11.OR.ISCHM.EQ.21)THEN
C  Original LDA+U after Liechtenstein et.al (Rotationally Invariant)
C  dVup=U*Ndn+(U-J)Nup-d*[<U>(<N>-1/2)+<J>(<Nup>-1/2)]
C  dVdn=U*Nup+(U-J)Ndn-d*[<U>(<N>-1/2)+<J>(<Ndn>-1/2)]
        DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)=
     &  DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)+UMAT(IU,IU1)*
     &  DELDHUB(IU1,IATOM,ISPIN1,IGPTB,MY)+
     &  (UMAT(IU,IU1)-GMAT(IU,IU1))*
     &  DELDHUB(IU1,IATOM,ISPIN,IGPTB,MY)
	ELSEIF(ISCHM.EQ.12.OR.ISCHM.EQ.22)THEN
C  LDA+U with another double counting. I like it better...
C  dVup=U*[Ndn-Ndn_LDA]+(U-J)[Nup-Nup_LDA]
C  dVdn=U*[Nup-Nup_LDA]+(U-J)[Ndn-Ndn_LDA]
	DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)=
     &  DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)+(
     &  DELDHUB(IU1,IATOM,ISPIN1,IGPTB,MY)-
     &  DELDLDA(IU1,IATOM,ISPIN1,IGPTB,MY))*UMAT(IU,IU1)+(
     &  DELDHUB(IU1,IATOM,ISPIN,IGPTB,MY )-
     &  DELDLDA(IU1,IATOM,ISPIN,IGPTB,MY ))*
     &  (UMAT(IU,IU1)-GMAT(IU,IU1))
	ELSEIF(ISCHM.EQ.13.OR.ISCHM.EQ.23)THEN
C  LDA+U with average occupancies. I like it best of all...
C  dVup=U*[Ndn-Nav]+(U-J)[Nup-Nav]
C  dVdn=U*[Nup-Nav]+(U-J)[Ndn-Nav]
	DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)=
     &  DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)+UMAT(IU,IU1)*
     &  (DELDHUB(IU1,IATOM,ISPIN1,IGPTB,MY)-DAVR(IU1,IATOM))+
     &  (DELDHUB(IU1,IATOM,ISPIN ,IGPTB,MY )-DAVR(IU1,IATOM))*
     &  (UMAT(IU,IU1)-GMAT(IU,IU1))
	ELSEIF((ISCHM.EQ.14.OR.ISCHM.EQ.24).
     &            AND.K1.EQ.K.AND.M1.EQ.M)THEN
C  LDA+U in the spherically-averaged form. There is no matrix multiplication
C  V(j,l,sigma)=(Ubar-Jbar)*{0.5*delta(j,l)-rho(j,l,sigma)}
        DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)=-(UBAR(L,L1)-GBAR(L,L1))*
     &  DELDHUB(IU,IATOM,ISPIN,IGPTB,MY)
	ENDIF
	ENDDO                                     !!! over k1
	ENDDO                                     !!! over m1
C  ADD DIAGONAL TERMS
        IF(K.EQ.M.AND.(ISCHM.EQ.11.OR.ISCHM.EQ.21))
     &  DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)=
     &  DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)-UBAR(L,L1)*
     &  ((DBAR(L1,IATOM,1)+DBAR(L1,IATOM,NSPIN))/2.D0*DBLE(NSPIN)-
     &  0.5D0)+GBAR(L,L1)*(DBAR(L1,IATOM,ISPIN)-0.5D0)
        IF(K.EQ.M.AND.(ISCHM.EQ.14.OR.ISCHM.EQ.24))
     &  DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)=
     &  DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)+
     &  0.5D0*(UBAR(L,L1)-GBAR(L,L1))
	ENDDO                                     !!! over l1
	ENDDO                                     !!! over k
	ENDDO                                     !!! over m
	ENDDO                                     !!! over l
	ENDDO                                     !!! over spins
1000	CONTINUE                                  !!! over atoms
	END



	SUBROUTINE DELBHUBB(IGPTB,MY,IQPNT)
**********************************************************
*  Computes Hubbard correction to the LDA potential in   *
*  the LDA+U scheme.                                     *
*  The important parameter is ISCHM=0,11,12,13,...       *
*  in COMMON/HUBDAT/. See formulae below for a           *
*  particular scheme.                                    *
*  Last revised 16.01.99                                 *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &   ,NKAP(NPANMAX),IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,MCRL(NPAT),LCRL(0:LMAXB,NPAT)
	DIMENSION SMT(NSORTMAX)
     &   ,UMAT(LIMLMB2,LIMLMB2),GMAT(LIMLMB2,LIMLMB2)
     &   ,UBAR(0:LMAXB,0:LMAXB),GBAR(0:LMAXB,0:LMAXB)
	COMPLEX*16 
     &    VCNS(LIMLMB2,NPAT,NSPINMAX),VHUB(LIMLMB2,NPAT,NSPINMAX)
     &   ,DHUB(LIMLMB2,NPAT,NSPINMAX),DLDA(LIMLMB2,NPAT,NSPINMAX)
     &   ,DBAR(0:LMAXB,NPAT,NSPINMAX),DAVR(LIMLMB2,NPAT)
     &   ,DELVHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELBHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELDHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELVCNS(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELBCNS(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELDLDA(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
	LOGICAL LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
	CHARACTER*10 TXTEL(NSORTMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from readini
	COMMON /POTCOM/ SWZ,SMT                              !!! from vfull
	COMMON /KAPPAR/ NPAN,NKAP                            !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
	COMMON /STORE1/ UMAT,GMAT,UBAR,GBAR                  !!! from ttrint
	COMMON /HUBCOM/ DHUB,VHUB,DLDA,VCNS                  !!! from hubpot
        COMMON /HUBDAT/ NHUB,MCRL,LCRL,ISCHM                 !!! from readhub
        COMMON /DELHUB/ DELDHUB,DELMHUB,DELVHUB,DELBHUB
     &                 ,DELDLDA,DELVCNS,DELBCNS
	COMMON /SPIN/   NSPIN                                !!! from readini
        COMMON /ORBS/   NORBS                                !!! from readini
        COMMON /INP1/   ICHUB                                !!! from readini
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /TXTEL/  TXTEL                                !!! from readini
	DATA PI/3.141592653589793D0/
	IF(ICHUB.EQ.0)RETURN
        IF(NORBS.EQ.1.AND.(MY.EQ.0.OR.MY.EQ.2))RETURN
C  DO GLOBALLY OVER ATOMS
	DO 1000 IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	CALL HUBMAT(IATOM) !!! set Hubbard and Exchange matrices
C  SET AVERAGE OCCUPANCIES <Nup> and <Ndn>
	DO ISPIN=1,NSPIN                          !!! over spins
	DO L=0,ILSB(ISORT)                        !!! over l
	DBAR(L,IATOM,ISPIN)=(0.D0,0.D0)
	DO M=-L,L                                 !!! over m
	LM=L*(L+1)+M+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M+1           !  (l,m m) packed
	DBAR(L,IATOM,ISPIN)=DBAR(L,IATOM,ISPIN)+
     &  DELDHUB(IU,IATOM,ISPIN,IGPTB,MY)
	ENDDO                                     !!! over m
	ENDDO                                     !!! over l
	ENDDO                                     !!! over spins
C  SET AVERAGE OVER SPINS ONLY
	DO L=0,ILSB(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	DO K=-L,L                                 !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
        DAVR(IU,IATOM)=(DELDHUB(IU,IATOM,1,IGPTB,MY)+
     &  DELDHUB(IU,IATOM,NSPIN,IGPTB,MY))/2.D0
	ENDDO                                     !!! over m
	ENDDO                                     !!! over k
	ENDDO                                     !!! over l
C  SET HUBBARD CORRECTION TO THE POTENTIAL
	DO ITRAN=1,NSPIN                          !!! over spins
	IF(ITRAN.EQ.1)ITRAN1=NSPIN
	IF(ITRAN.EQ.NSPIN)ITRAN1=1
	DO L=0,ILSB(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	DO K=-L,L                                 !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	DELBHUB(IU,IATOM,ITRAN,IGPTB,MY)=(0.D0,0.D0)
	DELBCNS(IU,IATOM,ITRAN,IGPTB,MY)=(0.D0,0.D0)
	IF(ABS(DHUB(IU,IATOM,1)-DHUB(IU,IATOM,NSPIN)).GT.1.D-05)
     &  DELBHUB(IU,IATOM,ITRAN,IGPTB,MY)=-0.5D0*
     &  (VHUB(IU,IATOM,1)-VHUB(IU,IATOM,NSPIN))/
     &  (DHUB(IU,IATOM,1)-DHUB(IU,IATOM,NSPIN))*
     &  DELMHUB(IU,IATOM,ITRAN1,IGPTB,MY)
	ENDDO                                     !!! over k
	ENDDO                                     !!! over m
	ENDDO                                     !!! over l
	ENDDO                                     !!! over spins
1000	CONTINUE                                  !!! over atoms
	END
