	SUBROUTINE DINLMAT(IGPTB,MY,IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Calculates pseudopotential contribution to the         *
*  change in the hamiltonian and overlap matrix using     *
*  fourier transform.                                     * 
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,NKAP(NPANMAX),LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &    ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),ILSV(NSORTMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
	COMPLEX*16 DELVT,VINT0Q(NDIMMAX,NDIMMAX)
     &    ,XFUN0(NDIMMAX,0:MBASMAX),XFUNQ(NDIMMAX,0:MBASMAX)
     &    ,EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
     &    ,DHMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &    ,DOMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &    ,PSIK(0:NBASMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,PSIQ(0:NBASMAX,NORBSMAX,NDIMMAX*NSPINMAX)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTK(3),PNTQ(3)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),ORTH(2:3)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
        CHARACTER SCNFILE(0:NENVMAX,-1:2,100)*60
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
        COMMON /SPIN/   NSPIN                                !!! from init
        COMMON /ORBS/   NORBS                                !!! from init
C Inputs:
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
	COMMON /INDX/   IND                                  !!! from lmtpar
C Plane waves:
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
	COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
	COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
C Temporary:
	COMMON /STORE1/ XFUN0,XFUNQ,VINT0Q                   !!! tmp.storage
	COMMON /STORE2/ DHMAT,DOMAT                          !!! from dintmat
	COMMON /DELRO/  PSIK,PSIQ,PNTK,PNTQ                  !!! from psivec
C Outputs:
        COMMON /OUT0PH/ SCNFILE                              !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
	IF(KEYT.EQ.0)RETURN
	IF(MODE.NE.5)IBNDMIN=1
	IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)
	IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
	IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C ***** DO GLOBALLY OVER SPINORS ********
        DO 4000 IUPDN1=1,NSPIN                    !!! over spinors
        IF(NORBS.EQ.2)IORBS1=IUPDN1
        IF(NORBS.EQ.1)IORBS1=1
        DO 3000 IUPDN =1,NSPIN                    !!! over spinors
        IF(NORBS.EQ.2)IORBS=IUPDN
        IF(NORBS.EQ.1)IORBS=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
            IF(IUPDN1.EQ.1.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE. 0)GOTO3000
        ISPIN=1
        ITRAN=0
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE. 0)GOTO3000
        ISPIN=2
        ITRAN=0
        ELSEIF(IUPDN1.EQ.1.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.+1)GOTO3000
        ISPIN=0
        ITRAN=2
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.-1)GOTO3000
        ISPIN=0
        ITRAN=1
        ENDIF
C  **** CHANGE IN THE INTERSTITIAL POTENTIAL PARAMETERS
        DO 2000 IBNDS1=1,NSPIN                    !!! over spin subbands
        IF(NORBS.EQ.1.AND.IUPDN1.NE.IBNDS1)GOTO2000
        DO 1000 IBNDS=1,NSPIN                     !!! over spin subbands
        IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)GOTO1000
C  READ POTENTIAL PARAMETERS
        NRECL=NVAL*(2*NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &  NBNDT(IPAN)**2)
	IF(ISPIN.NE.0)THEN
        OPEN(UNIT=45,FILE=SCNFILE(IGPTB,MY,45),STATUS='OLD',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	IREC=ISPIN
	READ(45,REC=IREC)((VINT0Q(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((XFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((XFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
	CLOSE(45)
	ELSEIF(ITRAN.NE.0)THEN
        OPEN(UNIT=46,FILE=SCNFILE(IGPTB,MY,46),STATUS='OLD',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	IREC=ITRAN
	READ(46,REC=IREC)((VINT0Q(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((XFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((XFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
	CLOSE(46)
	ENDIF
C  TRASFERE TO BAND REPRESENTATION
	CALL TRVINT(PNTK,IORBS1,IBNDS1,IORBS,IBNDS,IPAN)
	CALL TRXFUN(PNTK,IORBS ,IBNDS ,IPAN,'0N*0N')
	CALL TRXFUN(PNTK,IORBS1,IBNDS1,IPAN,'QN*QC') 
C  COMPUTE CONTRIBUTION
        DO IBNDT1=IBNDMIN,IBNDMAX                 !!! over all bands
        IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
        DO IBNDT=IBNDMIN,IBNDMAX                  !!! over all bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	DELVT=VINT0Q(IBNDT1,IBNDT)
	DO IBAS=0,MIN(NBAS,MBAS)
	DELVT=DELVT+
     &  DCONJG(PSIQ(IBAS,IORBS1,IBAND1))*XFUN0(IBNDT,IBAS)+
     &  XFUNQ(IBNDT1,IBAS)*PSIK(IBAS,IORBS,IBAND)
	ENDDO
	DHMAT(IBAND1,IBAND)=DHMAT(IBAND1,IBAND)+DELVT
	ENDDO
	ENDDO
1000    CONTINUE                                  !!! over spin subbands
2000    CONTINUE                                  !!! over spin subbands
3000    CONTINUE                                  !!! over spinors
4000    CONTINUE                                  !!! over spinors
	END





	SUBROUTINE TRVINT(PNTK,IORBS1,IBNDS1,IORBS,IBNDS,IPAN)
***********************************************************
*  Transfers from lm-reperesentation to the band one.     *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,NKAP(NPANMAX),LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
	COMPLEX*16 EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
     &    ,APHK(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,APJK(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,APHQ(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,APJQ(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,EXPK1,EXPK
	COMPLEX*16 VINT0Q(NDIMMAX,NDIMMAX),SUM(NDIMMAX)
     &    ,XFUN0(NDIMMAX,0:MBASMAX),XFUNQ(NDIMMAX,0:MBASMAX)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),ORTH(2:3)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTK(3)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from init
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /ORBS/   NORBS                                !!! from init
C Inputs:
        COMMON /BASIS/  TAU                                  !!! from init
        COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
        COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
        COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
        COMMON /INDX/   IND                                  !!! from lmtpar
        COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
C Plane waves:
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
        COMMON /EIGVEC/ APHK,APJK,APHQ,APJQ                  !!! from lmtvec
        COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
C Temporary:
        COMMON /STORE1/ XFUN0,XFUNQ,VINT0Q                   !!! tmp.storage
C Bands:
        COMMON /UNIT/   IUN                                  !!! from init
        COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
	IF(MODE.NE.5)IBNDMIN=1
	IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)
	IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
	IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C  DO OVER LEFT INDEX
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	DO L1=0,ILSB(ISORT1)              !!! over l1
	DO M1=-L1,L1                      !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=IND(L1M1,IATOM1,IKAP1,1,IPAN)
C  TRANSFERE RIGHT INDEX
	DO IBNDT=IBNDMIN,IBNDMAX          !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	SUM(IBNDT)=(0.D0,0.D0)
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &      PNTK(2)*TAU(2,IATOM)+
     &      PNTK(3)*TAU(3,IATOM)
	EXPK=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	DO L=0,ILSB(ISORT)                !!! over l
	DO M=-L,L                         !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=IND(LM,IATOM,IKAP,1,IPAN)
	SUM(IBNDT)=SUM(IBNDT)+
     &  VINT0Q(IPAR1,IPAR)*EXPK*APHK(LM,IATOM,IKAP,IORBS,IBAND)
	ENDDO                             !!! over m
	ENDDO                             !!! over l
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom
	ENDDO                             !!! over bands
	DO IBNDT=IBNDMIN,IBNDMAX
	VINT0Q(IPAR1,IBNDT)=SUM(IBNDT)
	ENDDO
	ENDDO                             !!! over m1
	ENDDO                             !!! over l1
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom1
C  TRANSFERE LEFT INDEX
	DO IBNDT=IBNDMIN,IBNDMAX          !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IBNDT1=IBNDMIN,IBNDMAX         !!! over bands
        IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	SUM(IBNDT1)=(0.D0,0.D0)
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
	SCP=PNTK(1)*TAU(1,IATOM1)+
     &      PNTK(2)*TAU(2,IATOM1)+
     &      PNTK(3)*TAU(3,IATOM1)
	EXPK1=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	DO L1=0,ILSB(ISORT1)              !!! over l1
	DO M1=-L1,L1                      !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=IND(L1M1,IATOM1,IKAP1,1,IPAN)
	SUM(IBNDT1)=SUM(IBNDT1)+VINT0Q(IPAR1,IBNDT)*
     &  DCONJG(APHQ(L1M1,IATOM1,IKAP1,IORBS1,IBAND1)*EXPK1)
	ENDDO                             !!! over m1
	ENDDO                             !!! over l1
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom1
	ENDDO                             !!! over bands
	DO IBNDT1=IBNDMIN,IBNDMAX
	VINT0Q(IBNDT1,IBNDT)=SUM(IBNDT1)
	ENDDO
	ENDDO                             !!! over bands
	END




	SUBROUTINE TRXFUN(PNTK,IORBS,IBNDS,IPAN,TGO)
***********************************************************
*  Transfers from lm-reperesentation to the band one.     *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,NKAP(NPANMAX),LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
	COMPLEX*16 EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
     &    ,APHK(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,APJK(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,APHQ(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,APJQ(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,EXPK1,EXPK
	COMPLEX*16 VINT0Q(NDIMMAX,NDIMMAX),SUM(NDIMMAX)
     &    ,XFUN0(NDIMMAX,0:MBASMAX),XFUNQ(NDIMMAX,0:MBASMAX)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),ORTH(2:3)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTK(3)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER TGO*5
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from init
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /ORBS/   NORBS                                !!! from init
C Inputs:
        COMMON /BASIS/  TAU                                  !!! from init
        COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
        COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
        COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
        COMMON /INDX/   IND                                  !!! from lmtpar
C Plane waves:
        COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
        COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
C Temporary:
        COMMON /STORE1/ XFUN0,XFUNQ,VINT0Q                   !!! tmp.storage
C Bands:
        COMMON /EIGVEC/ APHK,APJK,APHQ,APJQ                  !!! from lmtvec
C Outputs:
        COMMON /UNIT/   IUN                                  !!! from init
        COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
	IF(MODE.NE.5)IBNDMIN=1
	IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)
	IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
	IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C  TRANSFERE XFUN-VECTORS
	DO IBAS=0,MIN(NBAS,MBAS)          !!! over ibas
	DO IBNDT=IBNDMIN,IBNDMAX          !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	SUM(IBNDT)=(0.D0,0.D0)
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &      PNTK(2)*TAU(2,IATOM)+
     &      PNTK(3)*TAU(3,IATOM)
	EXPK=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	DO L=0,ILSB(ISORT)                !!! over l
	DO M=-L,L                         !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=IND(LM,IATOM,IKAP,1,IPAN)
	IF(TGO.EQ.'0N*0N')
     &  SUM(IBNDT)=SUM(IBNDT)+XFUN0(IPAR,IBAS)*
     &  EXPK*APHK(LM,IATOM,IKAP,IORBS,IBAND)
	IF(TGO.EQ.'QN*QC')
     &  SUM(IBNDT)=SUM(IBNDT)+XFUNQ(IPAR,IBAS)*
     &  DCONJG(EXPK*APHQ(LM,IATOM,IKAP,IORBS,IBAND))
	ENDDO                             !!! over m
	ENDDO                             !!! over l
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom
	ENDDO                             !!! over bands
	DO IBNDT=IBNDMIN,IBNDMAX
	IF(TGO(1:1).EQ.'0')XFUN0(IBNDT,IBAS)=SUM(IBNDT)
	IF(TGO(1:1).EQ.'Q')XFUNQ(IBNDT,IBAS)=SUM(IBNDT)
	ENDDO
	ENDDO                             !!! over ibas
	END
