	SUBROUTINE DELVCFTR(IGPTB,MY,IQPNT,ISCR)
*********************************************************
* Calculates coulomb part of pseudopotential which is   *
* true Coulomb potential in the interstitial region.    *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,INDZPTB(NENVMAX)
	COMPLEX*16 
     &     DPOTPS(0:NPLWMAX,NSPINMAX),DBXCPS(0:NPLWMAX,NSPINMAX)
     &    ,DPOTIN(0:NPLWMAX,NSPINMAX),DBXCIN(0:NPLWMAX,NSPINMAX)
     &    ,DRHOPS(0:NPLWMAX,NSPINMAX),DMAGPS(0:NPLWMAX,NSPINMAX)
     &    ,DRHOPS1(0:NPLWMAX,NSPINMAX),PSTOT
	DIMENSION SMT(NSORTMAX),GPLW(3,0:NPLWMAX),ORTH(2:3),QPNT(3)
     &    ,QPTB(3,NENVMAX)
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE     !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from init
	COMMON /POTCOM/ SWZ,SMT                          !!! from vfull
	COMMON /QMESH/  NQPNT,QPNT                       !!! from qvector
        COMMON /PLZCOM/ NPLZ,LPLZ,IPLZ,NZPTB,QPTB,INDZPTB!!! from init
	COMMON /DPSVCOM/DPOTPS,DBXCPS,DPOTIN,DBXCIN      !!! from dvcftr
	COMMON /DPSRHO/ DRHOPS,DMAGPS,DRHOPS1            !!! from vcftr
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from init
	COMMON /PLWMESH/NPLW,GPLW                        !!! from plwmsh
	COMMON /ORBS/   NORBS                            !!! from init
	COMMON /SPIN/   NSPIN                            !!! from init
	COMMON /WORD/   NVAL                             !!! from nmtdata
	DATA PI/3.141592653589793D0/
	IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)RETURN
	DO ISPIN=1,NSPIN                     !!! over spins
	DO IPLW=0,NPLW                       !!! over plane waves
	GX=(GPLW(1,IPLW)+QPNT(1))*2.D0*PI/PAR
	GY=(GPLW(2,IPLW)+QPNT(2))*2.D0*PI/PAR
	GZ=(GPLW(3,IPLW)+QPNT(3))*2.D0*PI/PAR
	G2=GX**2+GY**2+GZ**2
	PSTOT=(0.D0,0.D0)
	PSTOT=PSTOT+(DRHOPS (IPLW,1)+DRHOPS (IPLW,NSPIN))/
     &  2.D0*DBLE(NSPIN) 
	PSTOT=PSTOT+(DRHOPS1(IPLW,1)+DRHOPS1(IPLW,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	IF(G2.GE.1.D-10)
     &  DPOTPS(IPLW,ISPIN)=DPOTPS(IPLW,ISPIN)+8.D0*PI*PSTOT/G2
	IF(G2.LT.1.D-10)
     &  DPOTPS(IPLW,ISPIN)=DPOTPS(IPLW,ISPIN)+(0.D0,0.D0) ! for G=0 and q=0
        DO IZPTB=1,NZPTB
        IF(ISCR.EQ.1.AND.LPLZ.GT.0.AND.IPLW.EQ.INDZPTB(IZPTB))
     &  DPOTPS(IPLW,ISPIN)=DPOTPS(IPLW,ISPIN)+(0.D0,0.D0)
        ENDDO      
        ENDDO                                !!! over plane waves
        ENDDO                                !!! over spins
	END



	SUBROUTINE DELVPINT(IGPTB,MY,IQPNT)
*********************************************************
* Calculates convolution of pseudopotential with inter- *
* stitial plane-wave integral.                          *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,KGMIN(3),KGMAX(3),INDG(NFFTMAX),KVEC(3,0:NPLWMAX)
     &   ,INDG2(9*NFFTMAX)
	COMPLEX*16 
     &    DPOTPS(0:NPLWMAX,NSPINMAX),DBXCPS(0:NPLWMAX,NSPINMAX)
     &   ,DPOTIN(0:NPLWMAX,NSPINMAX),DBXCIN(0:NPLWMAX,NSPINMAX)
     &   ,GVAL,GINT(0:9*NPLWMAX)
	DIMENSION SMT(NSORTMAX),GPLW(3,0:NPLWMAX),ORTH(2:3)
     &   ,G2PLW(3,0:9*NPLWMAX),QPNT(3)
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE     !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from init
	COMMON /POTCOM/ SWZ,SMT                          !!! from vfull
	COMMON /DPSVCOM/DPOTPS,DBXCPS,DPOTIN,DBXCIN      !!! from dvpint   
	COMMON /QMESH/  NQPNT,QPNT                       !!! from qvector
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from init
	COMMON /STORE1/ GINT                             !!! from plwint
        COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG  !!! from plwmsh
        COMMON /PLW2MSH/N2PLW,G2PLW,INDG2     	         !!! from plw2mh
	COMMON /SPIN/   NSPIN                            !!! from init
	COMMON /WORD/   NVAL                             !!! from nmtdata
	DATA PI/3.141592653589793D0/
	M1D=2*KGMAX(1)-2*KGMIN(1)+1
	M2D=2*KGMAX(2)-2*KGMIN(2)+1
	M3D=2*KGMAX(3)-2*KGMIN(3)+1
	M12D=M1D*M2D
	M123D=M1D*M2D*M3D
C  SET CONVOLUTION FOR THE CHANGE IN THE PSEUDOPOTENTIAL
	CALL PLWINT(GINT)                    !!! take the integral for PWs
	DO ISPIN=1,NSPIN                     !!! over spins
	ITRAN=ISPIN
	DO IPLW=0,NPLW                       !!! over plane waves
	DPOTIN(IPLW,ISPIN)=(0.D0,0.D0)
	DBXCIN(IPLW,ITRAN)=(0.D0,0.D0)
	M1I=KVEC(1,IPLW)+2*KGMIN(1)
	M2I=KVEC(2,IPLW)+2*KGMIN(2)
	M3I=KVEC(3,IPLW)+2*KGMIN(3)
	DO JPLW=0,NPLW                       !!! over plane waves
        M1=KVEC(1,JPLW)-M1I
        M2=KVEC(2,JPLW)-M2I
        M3=KVEC(3,JPLW)-M3I
        IDIM=1+M1+M1D*M2+M12D*M3
	I2PLW=INDG2(IDIM)
	DPOTIN(IPLW,ISPIN)=DPOTIN(IPLW,ISPIN)+
     &  DPOTPS(JPLW,ISPIN)*GINT(I2PLW)
	DBXCIN(IPLW,ITRAN)=DBXCIN(IPLW,ITRAN)+
     &  DBXCPS(JPLW,ITRAN)*GINT(I2PLW)
        ENDDO                                !!! over plane waves
        ENDDO                                !!! over plane waves
        ENDDO                                !!! over spins
	END
