	SUBROUTINE FFTMSH
************************************************************
*  Prepares data for the fast fourier transform.           *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &     ,MDIV(3),ISVEC(0:NVCMAX),INTFFT(NFFTMAX)
	DIMENSION ORTH(2:3),RBAS(3,3),TAU(3,NPAT),GBAS(3,3)
     &     ,AD(3,3),RD(3,3),SMT(NSORTMAX),TAUT(3,NPAT)
     &     ,TVEC(3,0:NVCMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM   !!! from init
	COMMON /LATTICE/RBAS,GBAS                       !!! from init
	COMMON /BASIS/  TAU                             !!! from init
	COMMON /POTCOM/ SWZ,SMT                         !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                 !!! from init
	COMMON /FFTMESH/MDIV,AD,RD,INTFFT               !!! from fftmesh
	COMMON /UNIT/   IUN                             !!! from init
	DATA PI/3.141592653589793D0/
	NFFT=(MDIV(1)+1)*(MDIV(2)+1)*(MDIV(3)+1)
	IF(NFFT.GT.NFFTMAX)STOP'<FFTMSH>: INCREASE NFFTMAX IN PARAM.DAT'
C  SET PRIMITIVE TRANSLATIONS
	DO 10 J=1,3
	AD(J,1)=RBAS(J,1)/DBLE(MDIV(1))
	AD(J,2)=RBAS(J,2)/DBLE(MDIV(2))
	AD(J,3)=RBAS(J,3)/DBLE(MDIV(3))
  10    CONTINUE
C  SET TRANSLATIONS WHICH ARE RECIPROCAL TO AD
	CALL CROSS(RD(1,1),AD(1,2),AD(1,3))
	CALL CROSS(RD(1,2),AD(1,3),AD(1,1))
	CALL CROSS(RD(1,3),AD(1,1),AD(1,2))
	WD=AD(1,1)*RD(1,1)+AD(2,1)*RD(2,1)+AD(3,1)*RD(3,1)
	DO 20 I=1,3
	RD(I,1)=RD(I,1)/WD
	RD(I,2)=RD(I,2)/WD
	RD(I,3)=RD(I,3)/WD
  20    CONTINUE
C  FIND SPHERE RADIUS CIRCUMSCRIBING UNIT CELL
	SMAX=0.D0
	DO 25 ISORT=1,NSORT
	SMAX=MAX(SMAX,SMT(ISORT)/PAR)
  25    CONTINUE
	RMAX=0.D0
	DO 40 IZ=-1,1
	DO 40 JZ=-1,1
	DO 40 KZ=-1,1
	RSUM=0.D0
	DO 30 I=1,3
	RSUM=RSUM+(IZ*RBAS(I,1)+JZ*RBAS(I,2)+KZ*RBAS(I,3))**2
  30    CONTINUE
	RMAX=MAX(RMAX,RSUM)
  40    CONTINUE
	RMAX=SQRT(RMAX)+2.D0*SMAX+0.1D0
C  GENERATE ALL LATTICE SITES INSIDE SPHERE "RMAX"
	CALL SITEGEN(RMAX,RBAS(1,1),RBAS(1,2),RBAS(1,3),
     &  TAU,NATOM,NVEC,TVEC(1,0),ISVEC(0))
	NVEC=NVEC-1
C  CALCULATE WHICH POINTS ARE IN THE INTERSTITIALS
	IINT=0
	IMTS=0
	DO 80 MFFT3=0,MDIV(3)-1
	DO 70 MFFT2=0,MDIV(2)-1
	DO 60 MFFT1=0,MDIV(1)-1
	IFFT=1+MFFT1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
C  RADIUS-VECTOR IN THE INTERSTITIAL REGION IS GIVEN BY
	RSX=(MFFT1*AD(1,1)+MFFT2*AD(1,2)+MFFT3*AD(1,3))
	RSY=(MFFT1*AD(2,1)+MFFT2*AD(2,2)+MFFT3*AD(2,3))
	RSZ=(MFFT1*AD(3,1)+MFFT2*AD(3,2)+MFFT3*AD(3,3))
	IATOM=0
	DO 50 IVEC=0,NVEC
	TX=TVEC(1,IVEC)
	TY=TVEC(2,IVEC)
	TZ=TVEC(3,IVEC)
	DIF=SQRT((TX-RSX)**2+(TY-RSY)**2+(TZ-RSZ)**2)
	IF(DIF.LE.SMT(IS(ISVEC(IVEC)))/PAR)IATOM=ISVEC(IVEC)
  50    CONTINUE
	INTFFT(IFFT)=IATOM
	IF(IATOM.EQ.0)IINT=IINT+1
	IF(IATOM.GT.0)IMTS=IMTS+1
  60    CONTINUE
  70    CONTINUE
  80    CONTINUE
	NINT=IINT
	NMTS=IMTS
	IF(NINT+NMTS.NE.MDIV(1)*MDIV(2)*MDIV(3))PRINT*,
     &  '<FFTMSH>:: WRONG # OF INT (MTS) POINTS FOUND BY "INTFFT"'
	END
