	SUBROUTINE SLMTVEC(IPNT,ISGQ,IPAN,IQPNT)
************************************************************
*  Find LMTO-variational coefficients A(L,g*kj),S(L,g*kj)  *
*  at the point g*k of the Brillouin Zone. Find also these *
*  eigenvectors for the point g*k+q=g'*k'.                 *
*  Written by S.Savrasov in Max-Planck-Institute, Germany. *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NKAP(NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,IKOV(NOPRMAX),IP(NPAT,NOPRMAX),ISG(NOPRMAX,NOPRMAX)
     &   ,IG0IG1(KMAX,NOPRMAX),IK0IK1(KMAX,NOPRMAX)
     &   ,IRDCGG(KMAX,NOPRMAX),IATS(NPAT,NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,AHK(LIMLMB,NPAT,NKAPMAX),AJK(LIMLMT1,NPAT,NKAPMAX)
     &   ,AHQ(LIMLMB,NPAT,NKAPMAX),AJQ(LIMLMT1,NPAT,NKAPMAX)
     &   ,APHK(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APJK(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APHQ(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APJQ(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,U(NWIGMAX,48),PHSK,PHSQ,SOPHS(2,NOPRMAX)
	DIMENSION RDC(3,NPAT,NOPRMAX),PNT(3,KMAX),SHIFT(3,NOPRMAX)
	LOGICAL LOG,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE            !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM           !!! from init
	COMMON /INVERS/ INV,IKOV                                !!! from group
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                   !!! from init
	COMMON /EIGVEC/ APHK,APJK,APHQ,APJQ                     !!! for delmat 
	COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT,SOPHS            !!! from group
	COMMON /SUBGROUP/NSGQ,NGEQ,ISG                          !!! from symmsh
	COMMON /SYMMESH/IG0IG1,IK0IK1,IRDCGG                    !!! from symmsh
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                       !!! from init
	COMMON /MESH/   NPNT,PNT                                !!! from ttrmsh
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                       !!! from init
	COMMON /ORBS/   NORBS                                   !!! from init
	COMMON /SPIN/   NSPIN                                   !!! from init
	COMMON /UNIT/   IUN                                     !!! from init
	DATA PI/3.141592653589793D0/
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  SET READING INFORMATION
        NSHIFT=0
        DO JPAN=1,IPAN-1
        NSHIFT=NSHIFT+NKAP(JPAN)*NBNDT(JPAN)*
     &  NSPIN*NORBS*NPNT
        ENDDO
C  **** ROTATE EIGENVECTORS AFTER APPLYING POINT-GROUP OPERATIONS ****
        IF(MODE.NE.5)IBNDMIN=1
        IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)
        IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
        IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
	DO 3000 IBNDS=1,NSPIN                         !!! over spin subbands
	DO 2000 IORBS=1,NORBS                         !!! over spinors
        DO 1000 IBNDT=IBNDMIN,IBNDMAX                 !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IKAP=1,NKAP(IPAN)                          !!! over energies
C  READ EIGENVECTORS FOR THE POINT "K"
	IF(MODE.NE.5)
     &  IREC=1+IKAP+NKAP(IPAN)*(IBNDT-1)+
     &  NKAP(IPAN)*NBNDT(IPAN)*(IBNDS-1)+
     &  NKAP(IPAN)*NBNDT(IPAN)*NSPIN*(IORBS-1)+
     &  NKAP(IPAN)*NBNDT(IPAN)*NSPIN*NORBS*(IPNTK-1)+NSHIFT
	IF(MODE.EQ.5)
     &  IREC=1+IKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(IORBS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNTK-1)
        READ(15,REC=IREC)
     &  ((AHK(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM),
     &  ((AJK(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+2)**2),
     &  IATOM=1,NATOM)
C  READ EIGENVECTORS FOR THE POINT "K'"
	IF(MODE.NE.5)
     &  IREC=1+IKAP+NKAP(IPAN)*(IBNDT-1)+
     &  NKAP(IPAN)*NBNDT(IPAN)*(IBNDS-1)+
     &  NKAP(IPAN)*NBNDT(IPAN)*NSPIN*(IORBS-1)+
     &  NKAP(IPAN)*NBNDT(IPAN)*NSPIN*NORBS*(IPNTQ-1)+NSHIFT
	IF(MODE.EQ.5)
     &  IREC=1+IKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(IORBS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNTQ-1)
        READ(15,REC=IREC)
     &  ((AHQ(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM),
     &  ((AJQ(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+2)**2),
     &  IATOM=1,NATOM)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SK=PNT(1,IPNTK)*RDC(1,IATOM,IRK)+
     &     PNT(2,IPNTK)*RDC(2,IATOM,IRK)+
     &     PNT(3,IPNTK)*RDC(3,IATOM,IRK)
	SQ=PNT(1,IPNTQ)*RDC(1,IATOM,IRQ)+
     &     PNT(2,IPNTQ)*RDC(2,IATOM,IRQ)+
     &     PNT(3,IPNTQ)*RDC(3,IATOM,IRQ)
	PHSK=EXP(2.D0*PI*SK*(0.D0,1.D0))
	PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
	DO L=0,ILST(ISORT)+1                          !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	LL=L*(2*L-1)*(2*L+1)/3
	DO M=-L,L                                     !!! over m
	LM=L*(L+1)+M+1
	IF(L.LE.ILSB(ISORT))
     &  APHK(LM,IATOM,IKAP,IORBS,IBAND)=(0.D0,0.D0)
	IF(L.LE.ILSB(ISORT))
     &  APHQ(LM,IATOM,IKAP,IORBS,IBAND)=(0.D0,0.D0)
	APJK(LM,IATOM,IKAP,IORBS,IBAND)=(0.D0,0.D0)
	APJQ(LM,IATOM,IKAP,IORBS,IBAND)=(0.D0,0.D0)
C  ROTATE EIGENVECTORS FROM THE POINT "K" TO THE POINT "G*K"
	DO M1=-L,L                                    !!! over m1
	LM1=L*(L+1)+M1+1
	IWIG01=LL+(2*L+1)*(L+M1)+L+M+1
	IF(LOG)
     &  APHK(LM,IATOM,IKAP,IORBS,IBAND)=
     &  APHK(LM,IATOM,IKAP,IORBS,IBAND)+
     &  U(IWIG01,IGK)*AHK(LM1,IP(IATOM,IRK),IKAP)*PHSK*
     &  SOPHS(IORBS,IRK)
	APJK(LM,IATOM,IKAP,IORBS,IBAND)=
     &  APJK(LM,IATOM,IKAP,IORBS,IBAND)+
     &  U(IWIG01,IGK)*AJK(LM1,IP(IATOM,IRK),IKAP)*PHSK*
     &  SOPHS(IORBS,IRK)
        ENDDO                                         !!! over m1
C  ROTATE EIGENVECTORS FROM THE POINT "K'" TO THE POINT "G'*K'=G*K+Q"
	DO M1=-L,L                                    !!! over m1
	LM1=L*(L+1)+M1+1
	IWIG01=LL+(2*L+1)*(L+M1)+L+M+1
	IF(LOG)
     &  APHQ(LM,IATOM,IKAP,IORBS,IBAND)=
     &  APHQ(LM,IATOM,IKAP,IORBS,IBAND)+
     &  U(IWIG01,IGQ)*AHQ(LM1,IP(IATOM,IRQ),IKAP)*PHSQ*
     &  SOPHS(IORBS,IRQ)
	APJQ(LM,IATOM,IKAP,IORBS,IBAND)=
     &  APJQ(LM,IATOM,IKAP,IORBS,IBAND)+
     &  U(IWIG01,IGQ)*AJQ(LM1,IP(IATOM,IRQ),IKAP)*PHSQ*
     &  SOPHS(IORBS,IRQ)
        ENDDO                                         !!! over m1
        ENDDO                                         !!! over m
        ENDDO                                         !!! over l
        ENDDO                                         !!! over atoms
        ENDDO                                         !!! over energies
1000	CONTINUE                                      !!! over bands
2000	CONTINUE                                      !!! over spinors
3000	CONTINUE                                      !!! over spin subbands
	END
