	SUBROUTINE MULTFTR
*********************************************************
* Calculate multipoles as reciprocal lattice sums.      *
* Written by S.Yu.Savrasov (Lebedev Physical Institute) *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,LMSYM(LMMAXV,NPAT)
	COMPLEX*16 VPS(0:NPLWMAX,NSPINMAX),RHOPS(0:NPLWMAX,NSPINMAX)
     &    ,AMTOT(NSYMMAX,NPAT,NSPINMAX),PSMOM(NSYMMAX,NPAT,NSPINMAX)
     &    ,QMAD(2,NSYMMAX,NPAT,NSPINMAX),RHOPS1(0:NPLWMAX,NSPINMAX)
     &    ,YLM(LMMAXV),GAUS(0:LMAXV,NPAT),EXPT
     &    ,PSMOM1(NSYMMAX,NPAT,NSPINMAX)
	DIMENSION SMT(NSORTMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &    ,BET(0:LMAXV,NSORTMAX),GPLW(3,0:NPLWMAX),BES(-1:LMAXV)
     &    ,COFL(0:LMAXV,NSORTMAX),ORTH(2:3),TAU(3,NPAT)
     &    ,BESD(0:LMAXV)
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from init
	COMMON /POTCOM/ SWZ,SMT                          !!! from vfull
	COMMON /BASIS/  TAU                              !!! from init
	COMMON /PSVCOM/ VPS                              !!! from vpseudo
	COMMON /PSRHO/  RHOPS,RHOPS1                     !!! from vcftr
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from init
	COMMON /BETPAR/ BET                              !!! from multro
	COMMON /MULTRO/ Z,ZCOR,AMTOT,PSMOM,PSMOM1,QMAD   !!! from multro
	COMMON /SYMMLM/ SYM,LMSYM                        !!! from symmlm 
	COMMON /PLWMESH/NPLW,GPLW                        !!! from plwmsh
	COMMON /SPIN/   NSPIN                            !!! from init
	COMMON /WORD/   NVAL                             !!! from nmtdata
	DATA PI/3.141592653589793D0/
C  CALCULATE AUXILARY CHARGE DENSITY IN FOURIER REPRESENTATION
C  ALSO CALCULATE MULTIPOLE CHARGE FROM WHOLE SPACE
	LMM=0
	ZAUX=0.D0
	ZPSD=0.D0
	DO 40 ISPIN=1,NSPIN
	ZPSD=ZPSD+OMEGAC*RHOPS(0,ISPIN)
	DO 30 IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMM=MAX(LMM,ILSV(ISORT))
	ZAUX=ZAUX-DREAL(PSMOM1(1,IATOM,ISPIN))*SQRT(4.D0*PI)*SMT(ISORT)
	DO 20 L=0,ILSV(ISORT)
	COFL(L,ISORT)=4.D0*PI/OMEGAC*SMT(ISORT)**(L+1)/FAC2(2*L-1)
	DO 10 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	QMAD(1,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	QMAD(2,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	ENDIF
  10    CONTINUE
  20    CONTINUE
  30    CONTINUE
  40    CONTINUE
	REN1=ZPSD/ZAUX
	DO 140 IPLW=0,NPLW                   !!! over plane waves
	GX=GPLW(1,IPLW)*2.D0*PI/PAR
	GY=GPLW(2,IPLW)*2.D0*PI/PAR
	GZ=GPLW(3,IPLW)*2.D0*PI/PAR
	AG=SQRT(GX**2+GY**2+GZ**2)
	AG2=AG*AG
C  SET SPHERICAL HARMONICS
	IF(AG.GE.1.D-10)THEN
	CALL SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
	ELSE
	YLM(1)=1.D0/SQRT(4.D0*PI)
	DO 50 LM=2,(LMM+1)**2
	YLM(LM)=(0.D0,0.D0)
  50    CONTINUE
	ENDIF
C  SET AUXILARY PSEUDODENSITY PSRHO1
	DO 90 ISPIN=1,NSPIN                  !!! over spins
	RHOPS1(IPLW,ISPIN)=(0.D0,0.D0)
	DO 80 IATOM=1,NATOM                  !!! over atoms
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	SCP=GPLW(1,IPLW)*TAU(1,IATOM)+
     &      GPLW(2,IPLW)*TAU(2,IATOM)+
     &      GPLW(3,IPLW)*TAU(3,IATOM)
	EXPT=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO 70 L=0,ILSV(ISORT)
	IF(L.EQ.0)AGL=1.D0
	IF(L.NE.0)AGL=AG**L
	EXPG=EXP(-0.25D0*AG**2/BET(L,ISORT)**2)
	GAUS(L,IATOM)=COFL(L,ISORT)*EXPT*AGL*EXPG
	DO 60 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	RHOPS1(IPLW,ISPIN)=RHOPS1(IPLW,ISPIN)+
     &  GAUS(L,IATOM)*YLM(LM)*PSMOM1(ISYM,IATOM,ISPIN)*REN1
	ENDIF
  60    CONTINUE
  70    CONTINUE
  80    CONTINUE                             !!! over atoms
  90    CONTINUE                             !!! over spins
C  SET MULTIPOLE CHARGE
	IF(AG.GE.1.D-10)THEN                 !!! not for G=0 !
	DO 130 IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	CALL BESSR(AG*SMT(ISORT),BES(0),BESD(0),ILSV(ISORT))
	BES(-1)=COS(AG*SMT(ISORT))/(AG*SMT(ISORT))
	SCP=GPLW(1,IPLW)*TAU(1,IATOM)+
     &      GPLW(2,IPLW)*TAU(2,IATOM)+
     &      GPLW(3,IPLW)*TAU(3,IATOM)
	EXPT=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO 120 ISPIN=1,NSPIN                 !!! over spins
	DO 110 L=0,ILSV(ISORT)
	DO 100 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	QMAD(1,ISYM,IATOM,ISPIN)=QMAD(1,ISYM,IATOM,ISPIN)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*RHOPS(IPLW,ISPIN)*
     &  4.D0*PI*DCONJG(EXPT*YLM(LM))/AG*BES(L-1)
	QMAD(2,ISYM,IATOM,ISPIN)=QMAD(2,ISYM,IATOM,ISPIN)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*RHOPS1(IPLW,ISPIN)*
     &  4.D0*PI*DCONJG(EXPT*YLM(LM))/AG*BES(L-1)
	ENDIF
 100    CONTINUE
 110    CONTINUE
 120    CONTINUE                             !!! over spins
 130    CONTINUE                             !!! over atoms
	ENDIF
 140    CONTINUE                             !!! over plane waves
C  CHECK OUT PSEUDOCHARGE
	ZPS0=OMEGAC*(RHOPS (0,1)+RHOPS (0,NSPIN))/2.D0*DBLE(NSPIN)
	ZPS1=OMEGAC*(RHOPS1(0,1)+RHOPS1(0,NSPIN))/2.D0*DBLE(NSPIN)
	IF(ABS(ZPS0+ZPS1).GT.1.D-08)PRINT*,
     &  '<MULTFTR>: RENORMALISATION ERROR IN AUXILARY CHARGE'
	END
