	   SUBROUTINE MULTRHO
**************************************************************
*  Calculates multipoles from the mt-spheres.                *
*  Written by S.Yu.Savrasov, last revision: 25.11.94         *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT),NRAD(NSORTMAX)
	DIMENSION ZCOR(NSORTMAX),H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &    ,ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX),BET(0:LMAXV,NSORTMAX)
     &    ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),SMT(NSORTMAX),Z(NSORTMAX)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,BES(0:LMAXV+1),BESD(0:LMAXV+1),TAU(3,NPAT),GPLW(3,0:NPLWMAX)
     &    ,ORTH(2:3),BT(0:LMAXV+1)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),EXPT
     &    ,AMTOT(NSYMMAX,NPAT,NSPINMAX),PSMOM(NSYMMAX,NPAT,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX),WORK1(0:NRADMAX)
     &    ,RHOPS(0:NPLWMAX,NSPINMAX),RHOPS1(0:NPLWMAX,NSPINMAX)
     &    ,PSMOM1(NSYMMAX,NPAT,NSPINMAX),RHAN(0:LMAXV+1)
     &    ,YLM(LMMAXV),WORK2(0:NRADMAX)
	CHARACTER TXTEL(NSORTMAX)*10
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /BASIS/  TAU                                 !!! from init
	COMMON /DENS/   RO,ROVALDS,ROCOR                    !!! from rofull
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from radmsh
	COMMON /BETPAR/ BET                                 !!! from multro
	COMMON /PLWMESH/NPLW,GPLW                           !!! from plwmsh
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from init
	COMMON /PSRHO/  RHOPS,RHOPS1                        !!! from multro
	COMMON /MULTRO/ Z,ZCOR,AMTOT,PSMOM,PSMOM1           !!! from multro
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symlm
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C   CALCULATE MOMENTS OF THE FULL DENSITY AND PSEUDODENSITY WITHIN SPHERE
	ZINT=0.D0
	DO 60 ISPIN=1,NSPIN
	DO 50 IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO 40 L=0,ILSV(ISORT)
	DO 30 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN       !!! only for non-zero components
	ISYM=LMSYM(LM,IATOM)
	SL=SMT(ISORT)**L
	DO 10 IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=RO(IRAD,ISYM,IATOM,ISPIN)*
     &  RL(IRAD,L,ISORT)/SL*WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
  10    CONTINUE
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	AMTOT(ISYM,IATOM,ISPIN)=WORK2(NRAD(ISORT))
	ENDIF                      !!! only for non-zero components
  30    CONTINUE
  40    CONTINUE
	AMTOT(1,IATOM,ISPIN)=AMTOT(1,IATOM,ISPIN)-Z(ISORT)/DFLOAT(NSPIN)
	ZINT=ZINT-AMTOT(1,IATOM,ISPIN)
  50    CONTINUE
  60    CONTINUE
C  CALCULATE MOMENTS OF THE PSEUDOCHARGE DENSITY
	LMM=0
	ZPSD=0.D0
	DO 100 ISPIN=1,NSPIN
	ZPSD=ZPSD+OMEGAC*RHOPS(0,ISPIN)
	DO 90 IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMM=MAX(LMM,ILSV(ISORT))
	DO 80 L=0,ILSV(ISORT)
	DO 70 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	PSMOM(ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	ENDIF
  70    CONTINUE
  80    CONTINUE
  90    CONTINUE
 100    CONTINUE
	DO 160 IPLW=0,NPLW                   !!! over plane waves
	GX=GPLW(1,IPLW)*2.D0*PI/PAR
	GY=GPLW(2,IPLW)*2.D0*PI/PAR
	GZ=GPLW(3,IPLW)*2.D0*PI/PAR
	AG=SQRT(GX**2+GY**2+GZ**2)
	AG2=AG*AG
C  SET SPHERICAL HARMONICS
	IF(AG.GE.1.D-10)THEN
	CALL SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
	ELSE
	YLM(1)=1.D0/SQRT(4.D0*PI)
	DO 110 LM=2,(LMM+1)**2
	YLM(LM)=(0.D0,0.D0)
 110    CONTINUE
	ENDIF
C  SET MULTIPOLE MOMENTS
	DO 150 IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	CALL BESSR(AG*SMT(ISORT),BES,BESD,ILSV(ISORT)+1)
	SCP=GPLW(1,IPLW)*TAU(1,IATOM)+
     &      GPLW(2,IPLW)*TAU(2,IATOM)+
     &      GPLW(3,IPLW)*TAU(3,IATOM)
	EXPT=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	DO 140 ISPIN=1,NSPIN                 !!! over spins
	DO 130 L=0,ILSV(ISORT)
	DO 120 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	IF(AG.GT.1.D-10)THEN
	PSMOM(ISYM,IATOM,ISPIN)=PSMOM(ISYM,IATOM,ISPIN)+
     &  4.D0*PI*SMT(ISORT)**2*RHOPS(IPLW,ISPIN)*BES(L+1)*
     &  EXPT*DCONJG(YLM(LM))/AG*SQPI4
	ELSE
	PSMOM(ISYM,IATOM,ISPIN)=PSMOM(ISYM,IATOM,ISPIN)+
     &  4.D0*PI/3.D0*SMT(ISORT)**3*RHOPS(IPLW,ISPIN)*
     &  EXPT*DCONJG(YLM(LM))*SQPI4
	ENDIF
	ENDIF
 120    CONTINUE
 130    CONTINUE
 140    CONTINUE                             !!! over spins
 150    CONTINUE                             !!! over atoms
 160    CONTINUE                             !!! over plane waves
C  CALCULATE AUXILARY PSEUDOCHARGE DENSITY (ITS COEFFICIENTS)
C  WHICH HAS THE SAME MULTIPOLES AS A TRUE DENSITY MINUS PSEUDODENSITY
	DO 250 ISPIN=1,NSPIN
	DO 240 IATOM=1,NATOM
	ISORT=IS(IATOM)
	BT(0)=BET(0,ISORT)
	DO 210 L=1,ILSV(ISORT)+1
	BT(L)=BET(L-1,ISORT)
 210    CONTINUE
	CALL REGHAN(SMT(ISORT),(0.D0,0.D0),SMT(ISORT),BT(0),
     &  RHAN(0),ILSV(ISORT)+1)
	DO 230 L=0,ILSV(ISORT)
	DO 220 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN       !!! only for non-zero components
	ISYM=LMSYM(LM,IATOM)
C  GAUSSIAN MULTIPOLE MOMENT WITHIN SPHERE
	GSMOM=SQPI4*SMT(ISORT)*DBLE(2*L+1)*RHAN(L+1)
C  GAUSSIAN MULTIPOLE MOMENT IN WHOLE SPACE
C       GSMOM=SQPI4*SMT(ISORT)*DBLE(2*L+1)
	PSMOM1(ISYM,IATOM,ISPIN)=(AMTOT(ISYM,IATOM,ISPIN)-
     &  PSMOM(ISYM,IATOM,ISPIN))/GSMOM
	ENDIF
 220    CONTINUE
 230    CONTINUE
 240    CONTINUE
 250    CONTINUE
	END
