	SUBROUTINE ORBMAT(IPNT,IPAN)
************************************************************
*  Subroutine calculates contribution from spin-orbit      *
*  coupling to the hamiltonian.                            *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX),IS(NPAT)
     &    ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),NKAP(NPANMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,SPARHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,SPARJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,SPARHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,SPARJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &    ,SS(LIMLMT1,NPAT,LIMLMB,NPAT,NKAPMAX),HHH,OOO
     &    ,SSDOT(LIMLMB1,NPAT,LIMLMB,NPAT,NKAPMAX)
     &    ,HMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &    ,OMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
	DIMENSION SLM(LIMLMT,2),SMT(NSORTMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                      !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM          !!! from init
	COMMON /POTCOM/ SWZ,SMT                                !!! from init
	COMMON /DENS/   SS,SSDOT                               !!! from strgnt
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                      !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                  !!! from init
	COMMON /ORBPAR/ SPARHH,SPARJH,SPARHJ,SPARJJ            !!! from intpar
	COMMON /LATPAR/ PAR                                    !!! from init
	COMMON /STORE2/ HMAT,OMAT                              !!! for lmtbnd
	COMMON /INDX/   IND                                    !!! from lmtpar
	COMMON /ORBS/   NORBS                                  !!! from init
	COMMON /SPIN/   NSPIN                                  !!! from init
	COMMON /WORD/   NVAL                                   !!! from nmtdata
	IF(NORBS.EQ.1)RETURN
C  SET <Ylm|s*l|Ylm>/2 MATRIX ELEMENT
	DO L=0,LMAXT
	DO M=-L,L
	LM=L*(L+1)+M+1
	SLM(LM,1)=0.5D0*SQRT(DBLE((L-M)*(L+M+1)))
	SLM(LM,2)=0.5D0*SQRT(DBLE((L+M)*(L-M+1)))
	ENDDO
	ENDDO
C  ADD SPIN-ORBIT COUPLING TO THE HAMILTONIAN 
	DO 1000 IORBS=1,NORBS                         !!! over dn-up, up-dn parts
	IF(IORBS.EQ.1    )ISIGN=+1
	IF(IORBS.EQ.1    )ISPIN1=NSPIN
	IF(IORBS.EQ.1    )ISPIN =1
	IF(IORBS.EQ.NORBS)ISIGN=-1
	IF(IORBS.EQ.NORBS)ISPIN1=1
	IF(IORBS.EQ.NORBS)ISPIN =NSPIN
	DO IKAP1=1,NKAP(IPAN)                         !!! over energy
	DO IKAP =1,NKAP(IPAN)                         !!! over energy
	DO IATOM1=1,NATOM                             !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)                          !!! over l1
	IF(LTPAN(L1,IATOM1,IKAP1,IPAN))THEN
	DO M1=-L1,L1                                  !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IDIM1=IND(L1M1,IATOM1,IKAP1,ISPIN1,IPAN)
	DO IATOM=1,NATOM                              !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                            !!! over l
	IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
	DO M=-L,L                                     !!! over m
	LM=L*(L+1)+M+1
	IDIM=IND(LM,IATOM,IKAP,ISPIN,IPAN)
	HHH=(0.D0,0.D0)
C   ONE-CENTER TERM :
	IF(IATOM1.EQ.IATOM.AND.L1.EQ.L.AND.M1.EQ.M+ISIGN)
     &	HHH=HHH+SPARHH(IKAP1,IKAP,L,ISORT,IORBS)*SLM(LM,IORBS)
C   TWO-CENTER TERM :
	M2=M+ISIGN
	LM2=L*(L+1)+M2+1
	IF(ABS(M2).LE.L)
     &	HHH=HHH-SPARJH(IKAP1,IKAP,L,ISORT,IORBS)*SLM(LM,IORBS)*
     &  CONJG(SS(LM2,IATOM,L1M1,IATOM1,IKAP1))
C   TWO-CENTER TERM :
	M2=M1-ISIGN
	L1M2=L1*(L1+1)+M2+1
	IF(ABS(M2).LE.L1)
     &	HHH=HHH-SPARHJ(IKAP1,IKAP,L1,ISORT1,IORBS)*SLM(L1M2,IORBS)*
     &  SS(L1M2,IATOM1,LM,IATOM,IKAP)
C   THREE-CENTER TERM :
	DO KATOM=1,NATOM                             !!! over katom
	KSORT=IS(KATOM)
	DO L2=0,ILST(KSORT)                          !!! over l2
	DO M2=-L2,L2                                 !!! over m2
	M3=M2-ISIGN
	L2M2=L2*(L2+1)+M2+1
	L2M3=L2*(L2+1)+M3+1
	IF(ABS(M3).LE.L2)
     &	HHH=HHH+CONJG(SS(L2M2,KATOM,L1M1,IATOM1,IKAP1))*
     &  SPARJJ(IKAP1,IKAP,L2,KSORT,IORBS)*SLM(L2M3,IORBS)*
     &  SS(L2M3,KATOM,LM,IATOM,IKAP)
        ENDDO                                        !!! over m2
        ENDDO                                        !!! over l2
        ENDDO                                        !!! over katom
C   SET ZEROES WHERE NECESSARY
	HRE= DREAL(HHH)  ! real part of the hamiltonian matrix
	HIM= DIMAG(HHH)  ! imaginary part of the hamiltonian matrix
C       IF(ABS(HRE).LE.1.D-10)HRE=0.D0
C       IF(ABS(HIM).LE.1.D-10)HIM=0.D0
C   SET SPIN-ORBIT COUPLING IN THE HAMILTONIAN
        HMAT(IDIM1,IDIM)=HMAT(IDIM1,IDIM)+DCMPLX(HRE,+HIM)
C       HMAT(IDIM,IDIM1)=DCONJG(HMAT(IDIM1,IDIM))
        ENDDO                                        !!! over m
	ENDIF
        ENDDO                                        !!! over l
        ENDDO                                        !!! over iatom
        ENDDO                                        !!! over m1
	ENDIF
        ENDDO                                        !!! over l1
        ENDDO                                        !!! over iatom1
        ENDDO                                        !!! over energy
        ENDDO                                        !!! over energy
1000	CONTINUE                                     !!! over dn-up, up-dn parts
	END
