        SUBROUTINE PLWCRD(IQPNT)
***********************************************************
*  Generates coordination spheres in reciprocal space     *
*  for using in polarizability calculation.               *
***********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
     &   ,ILSV(NSORTMAX),NFFTG(3),IKOV(NOPRMAX),IP(NPAT,NOPRMAX)
     &   ,INDRSH(0:NPLWMAX),INDZPTB(NENVMAX),ISG(NOPRMAX,NOPRMAX)
     &   ,INZPTBR(NOPRMAX,NENVMAX)
        DIMENSION RBAS(3,3),GBAS(3,3),TAU(3,NPAT),ORTH(2:3)
     &   ,GPLW(3,0:NPLWMAX),GL(3),SMT(NSORTMAX),QPTB(3,NENVMAX)
     &   ,RDC(3,NPAT,NOPRMAX),SHIFT(3,NOPRMAX),QPNT(3)
        COMPLEX*16 U(NWIGMAX,48)
	LOGICAL EXIST
C Controls:
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from init
	COMMON /PLZCOM/ NPLZ,LPLZ,IPLZ,NZPTB,QPTB,INDZPTB,INZPTBR! from plwcrd
        COMMON /QMESH/  NQPNT,QPNT                            !!! from init
C Inputs:
        COMMON /LATTICE/RBAS,GBAS                             !!! from init
        COMMON /BASIS/  TAU                                   !!! from init
        COMMON /POTCOM/ SWZ,SMT                               !!! from init
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                       !!! from init
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG       !!! from plwmsh
        COMMON /ACCURG/ EPSR,EPSG,ECUTG                       !!! from init
        COMMON /FFTMESH/NFFTG                                 !!! from init
C Group:
        COMMON /INVERS/ INV,IKOV                              !!! from group
        COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT                !!! from group
        COMMON /SUBGROUP/NSGQ,NGEQ,ISG                        !!! from delmsh
C Outputs:
        COMMON /UNIT/   IUN                                   !!! from init
        COMMON /WORD/   NVAL                                  !!! from nmtdata
        DATA PI/3.141592653589793D0/
C  SET INDICATOR ARRAY TO ZERO
        DO IPLW=0,NPLW
        INDRSH(IPLW)=0
	ENDDO 
	NRSH=LPLZ-1
	GPLZ=SQRT(QPNT(1)**2+QPNT(2)**2+QPNT(3)**2)
        IRSH=0
C  DO OVER PLANE WAVES
        DO IPLW=1,NPLW                              !!! over iplw
        IF(INDRSH(IPLW).EQ.0)THEN
        IRSH=IRSH+1
C  RECIPROCAL LATTICE VECTOR IS GIVEN BY
        GX=GPLW(1,IPLW)
        GY=GPLW(2,IPLW)
        GZ=GPLW(3,IPLW)
        GRSH=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)
        IF(IRSH.EQ.NRSH)GPLZ=GRSH
        DO IR=1,NGROUP                              !!! over point group
C  APPLY SYMMETRY OPERATION
        IG=IKOV(IR)
        CALL ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),2)
C  GET COORDINATES IN G1,G2,G3
        X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
        X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
        X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
        M1R=ANINT(X1R)
        M2R=ANINT(X2R)
        M3R=ANINT(X3R)
        IF(ABS(DBLE(M1R)-X1R).GE.1.D-10.OR.
     &     ABS(DBLE(M2R)-X2R).GE.1.D-10.OR.
     &     ABS(DBLE(M3R)-X3R).GE.1.D-10)STOP'<TTRINT2>: WRONG VECTOR'
        IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
        IPLWR=INDG(IDIM)
        IF(IPLWR.EQ.-1)STOP'<PLWCRD>:: ERROR IN IPLWR'
        INDRSH(IPLWR)=IRSH
        ENDDO                                        !!! over group
	ENDIF
        ENDDO                                        !!! over iplw
	GPLZ=GPLZ+1.D-10
        NRSHTOT=IRSH                                 !!! total # of shells
C  SET PERTURBATION VECTORS
	IZPTB=0
	DO IPLW=0,NPLW                               !!! over iplw
	PTBX=QPNT(1)+GPLW(1,IPLW)
	PTBY=QPNT(2)+GPLW(2,IPLW)
	PTBZ=QPNT(3)+GPLW(3,IPLW)
	ZPTB=SQRT(PTBX**2+PTBY**2+PTBZ**2)
	IF(ZPTB.LE.GPLZ)THEN
	IZPTB=IZPTB+1
	IF(IZPTB.GT.NENVMAX)STOP
     &  '<PLWCRD>: NENVMAX MUST BE INCREASED IN PARAM.DAT'
	QPTB(1,IZPTB)=PTBX
	QPTB(2,IZPTB)=PTBY
	QPTB(3,IZPTB)=PTBZ
	INDZPTB(IZPTB)=IPLW
	ENDIF 
        ENDDO                                        !!! over iplw
	NZPTB=IZPTB
C  SORT VECTORS ACCORDING THE GROUP OF VECTOR Q
	DO IZPTB=1,NZPTB                             !!! over g-vectors
	GX=QPTB(1,IZPTB)-QPNT(1)
	GY=QPTB(2,IZPTB)-QPNT(2)
	GZ=QPTB(3,IZPTB)-QPNT(3)
        DO IGEQ=1,NGEQ                               !!! over group of q
C  APPLY INVERSIONAL SYMMETRY OPERATION
        IR=ISG(IGEQ,1)                       !!! element "g" in the main G-list
        IG=IKOV(IR)                          !!! element "g" after Kovalev
        CALL ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),1)
C  GET COORDINATES IN G1,G2,G3
        X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
        X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
        X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
        M1R=ANINT(X1R)
        M2R=ANINT(X2R)
        M3R=ANINT(X3R)
        IF(ABS(DBLE(M1R)-X1R).GE.1.D-10.OR.
     &     ABS(DBLE(M2R)-X2R).GE.1.D-10.OR.
     &     ABS(DBLE(M3R)-X3R).GE.1.D-10)STOP'<TTRINT2>: WRONG VECTOR'
        IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
        IPLWR=INDG(IDIM)
        IF(IPLWR.EQ.-1)STOP'<PLWCRD>:: ERROR IN IPLWR'
	IZPTBR=0
	DO JZPTB=1,NZPTB
	IF(INDZPTB(JZPTB).EQ.IPLWR)IZPTBR=JZPTB
        ENDDO   
	IF(IZPTBR.EQ.0)STOP'<PLWCRD>:: ERROR IN ROTATING G-VECTORS'
	INZPTBR(IGEQ,IZPTB)=IZPTBR                  !!! gamma^{-1}G=GR
        ENDDO                                       !!! over group of q
        ENDDO                                       !!! over g-vectors
C  PRINT OUT PERTURBATION VECTORS
	WRITE(IUN,1010)NZPTB
        WRITE(IUN,1020)
        DO IZPTB=1,NZPTB
	PTBX=QPTB(1,IZPTB)
	PTBY=QPTB(2,IZPTB)
	PTBZ=QPTB(3,IZPTB)
	ZPTB=SQRT(PTBX**2+PTBY**2+PTBZ**2)
	NCT=0
	DO JZPTB=1,NZPTB
	NT=0
	DO IGEQ=1,NGEQ
	IF(INZPTBR(IGEQ,IZPTB).EQ.JZPTB)NT=NT+1
	ENDDO 
	IF(NT.GT.0)NT=1
	NCT=NCT+NT
	ENDDO 
        WRITE(IUN,1030)QPTB(1,IZPTB),QPTB(2,IZPTB),
     &  QPTB(3,IZPTB),ZPTB,NCT
	ENDDO 
C  PRINT COORDINATION SPHERES IN RECIPROCAL SPACE
	WRITE(IUN,1040)
	DO IRSH=1,MIN(LPLZ+4,NRSHTOT)
	IPWS=0
	DO IPLW=1,NPLW
	IF(INDRSH(IPLW).EQ.IRSH)THEN
	PX=GPLW(1,IPLW)
	PY=GPLW(2,IPLW)
	PZ=GPLW(3,IPLW)
	GP=SQRT(PX**2+PY**2+PZ**2)
	IPWS=IPWS+1
	ENDIF
	ENDDO 
	WRITE(IUN,1050)IRSH,GP,IPWS
	ENDDO 
1010	FORMAT(1X,'Calculation of polarizability, # of vectors:',I3)
1020    FORMAT(1X,'    {q+G}x       {q+G}y       {q+G}z         |q+G|',
     &  8X,'DeG')
1030    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,')',2X,G12.5,2X,I4)
1040	FORMAT(1X,'Calculation of shells in reciprocal lattice:')
1050	FORMAT(1X,I2,'th: |G| = ',G14.7,' ; # of vectors = ',I3)
        RETURN
        END
