        SUBROUTINE PLWPTB(IQPNT)
***********************************************************
*  Generates coordination spheres in reciprocal space.    *
***********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
     &   ,ILSV(NSORTMAX),NFFTG(3),IKOV(NOPRMAX),IP(NPAT,NOPRMAX)
     &   ,INDRSH(0:NPLWMAX),INDGPTB(0:NENVMAX),ISG(NOPRMAX,NOPRMAX)
     &   ,INGPTBR(NOPRMAX,0:NENVMAX),NITER(0:NENVMAX,-1:2)
     &   ,INDGCON(0:NENVMAX,0:NENVMAX)
        DIMENSION RBAS(3,3),GBAS(3,3),TAU(3,NPAT),ORTH(2:3)
     &   ,GPLW(3,0:NPLWMAX),GL(3),SMT(NSORTMAX)
     &   ,RDC(3,NPAT,NOPRMAX),SHIFT(3,NOPRMAX),QPNT(3)
     &   ,GPTB(3,0:NENVMAX)
        COMPLEX*16 U(NWIGMAX,48)
        CHARACTER*60 SCNFILE(0:NENVMAX,-1:2,100)
     &   ,DROFILE(0:NENVMAX,-1:2),DPSFILE(0:NENVMAX,-1:2)
     &   ,DSVFILE(0:NENVMAX,-1:2),DPVFILE(0:NENVMAX,-1:2)
	LOGICAL EXIST
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE          !!! from init
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from readini
        COMMON /QMESH/  NQPNT,QPNT                            !!! from qvector
C Inputs:
        COMMON /LATTICE/RBAS,GBAS                             !!! from readstr
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB,INGPTBR,INDGCON! from plwptb
        COMMON /BASIS/  TAU                                   !!! from readstr
        COMMON /POTCOM/ SWZ,SMT                               !!! from readstr
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                       !!! from readini
        COMMON /MAGCOM/ ITERMAX,NITER                         !!! from readlrt
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG       !!! from plwmsh
        COMMON /ACCURG/ EPSR,EPSG,ECUTG                       !!! from readini
        COMMON /FFTMESH/NFFTG                                 !!! from readini
C Group:
        COMMON /INVERS/ INV,IKOV                              !!! from group
        COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT                !!! from group
        COMMON /SUBGROUP/NSGQ,NGEQ,ISG                        !!! from delmsh
C Outputs:
        COMMON /OUT0PH/ SCNFILE,DROFILE,DSVFILE,DPSFILE,DPVFILE!! from readlrt
        COMMON /UNIT/   IUN                                   !!! from readini
        COMMON /WORD/   NVAL                                  !!! from setup
        DATA PI/3.141592653589793D0/
C  SET INDICATOR ARRAY TO ZERO
        DO IPLW=0,NPLW
        INDRSH(IPLW)=0
	ENDDO
        IRSH=0
C  DO OVER PLANE WAVES
        DO IPLW=1,NPLW                              !!! over iplw
        IF(INDRSH(IPLW).EQ.0)THEN
        IRSH=IRSH+1
C  RECIPROCAL LATTICE VECTOR IS GIVEN BY
        GX=GPLW(1,IPLW)
        GY=GPLW(2,IPLW)
        GZ=GPLW(3,IPLW)
        GRSH=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)
        DO IR=1,NGROUP                              !!! over point group
C  APPLY SYMMETRY OPERATION
        IG=IKOV(IR)
        CALL ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),2)
C  GET COORDINATES IN G1,G2,G3
        X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
        X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
        X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
        M1R=ANINT(X1R)
        M2R=ANINT(X2R)
        M3R=ANINT(X3R)
        IF(ABS(DBLE(M1R)-X1R).GE.1.D-10.OR.
     &     ABS(DBLE(M2R)-X2R).GE.1.D-10.OR.
     &     ABS(DBLE(M3R)-X3R).GE.1.D-10)STOP'<PLWPTB>: WRONG VECTOR'
        IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
        IPLWR=INDG(IDIM)
        IF(IPLWR.EQ.-1)STOP'<PLWPTB>:: ERROR IN IPLWR'
        INDRSH(IPLWR)=IRSH
        ENDDO                                        !!! over group
	ENDIF
        ENDDO                                        !!! over iplw
        NRSHTOT=IRSH                                 !!! total # of shells
C  CHECK PERTURBATION VECTORS
	DO IGPTB=0,NGPTB                             !!! over g-vectors
	ICHK=0
	DO IPLW=0,NPLW                               !!! over iplw
	DX=GPLW(1,IPLW)-GPTB(1,IGPTB)
	DY=GPLW(2,IPLW)-GPTB(2,IGPTB)
	DZ=GPLW(3,IPLW)-GPTB(3,IGPTB)
	ABSD=SQRT(DX**2+DY**2+DZ**2)
	IF(ABSD.LE.1.D-10)INDGPTB(IGPTB)=IPLW
	IF(ABSD.LE.1.D-10)ICHK=ICHK+1
        ENDDO                                        !!! over iplw
	IF(ICHK.EQ.0.OR.ICHK.GT.1)STOP'<PLWPTB>:: ERROR IN GPTB'
	ENDDO                                        !!! over g-vectors
C  SORT VECTORS ACCORDING THE GROUP OF VECTOR Q
	DO IGPTB=0,NGPTB                             !!! over g-vectors
	GX=GPTB(1,IGPTB)
	GY=GPTB(2,IGPTB)
	GZ=GPTB(3,IGPTB)
	DO JGPTB=0,NGPTB
	INDGCON(IGPTB,JGPTB)=0
	ENDDO 
        DO IGEQ=1,NGEQ                               !!! over group of q
C  APPLY INVERSIONAL SYMMETRY OPERATION
        IR=ISG(IGEQ,1)                       !!! element "g" in the main G-list
        IG=IKOV(IR)                          !!! element "g" after Kovalev
        CALL ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),1)
C  GET COORDINATES IN G1,G2,G3
        X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
        X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
        X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
        M1R=ANINT(X1R)
        M2R=ANINT(X2R)
        M3R=ANINT(X3R)
        IF(ABS(DBLE(M1R)-X1R).GE.1.D-10.OR.
     &     ABS(DBLE(M2R)-X2R).GE.1.D-10.OR.
     &     ABS(DBLE(M3R)-X3R).GE.1.D-10)STOP'<TTRINT2>: WRONG VECTOR'
        IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
        IPLWR=INDG(IDIM)
        IF(IPLWR.EQ.-1)STOP'<PLWPTB>:: ERROR IN IPLWR'
	IGPTBR=-1
	DO JGPTB=0,NGPTB
	IF(INDGPTB(JGPTB).EQ.IPLWR)IGPTBR=JGPTB
	ENDDO
	IF(IGPTBR.EQ.-1)STOP'<PLWPTB>:: ERROR IN ROTATING G-VECTORS'
	INGPTBR(IGEQ,IGPTB)=IGPTBR                  !!! gamma^{-1}G=GR
	INDGCON(IGPTB,IGPTBR)=1
        ENDDO                                       !!! over group of q
        ENDDO                                       !!! over g-vectors
C  PRINT OUT PERTURBATION VECTORS
	WRITE(IUN,1010)NGPTB
        WRITE(IUN,1020)
        DO IGPTB=0,NGPTB
	PTBX=QPNT(1)+GPTB(1,IGPTB)
	PTBY=QPNT(2)+GPTB(2,IGPTB)
	PTBZ=QPNT(3)+GPTB(3,IGPTB)
	ABSG=SQRT(PTBX**2+PTBY**2+PTBZ**2)
	NCT=0
	DO JGPTB=0,NGPTB
	NT=0
	DO IGEQ=1,NGEQ
	IF(INGPTBR(IGEQ,IGPTB).EQ.JGPTB)NT=NT+1
	ENDDO
	IF(NT.GT.0)NT=1
	NCT=NCT+NT
	ENDDO
        WRITE(IUN,1030)PTBX,PTBY,PTBZ,ABSG,NCT
	ENDDO
C  PRINT COORDINATION SPHERES IN RECIPROCAL SPACE
	WRITE(IUN,1040)
	DO IRSH=0,MIN(NGSHL+4,NRSHTOT)
	IPWS=0
	DO IPLW=0,NPLW
	IF(INDRSH(IPLW).EQ.IRSH)THEN
	PX=GPLW(1,IPLW)
	PY=GPLW(2,IPLW)
	PZ=GPLW(3,IPLW)
	GP=SQRT(PX**2+PY**2+PZ**2)
	IPWS=IPWS+1
	ENDIF
	ENDDO 
	WRITE(IUN,1050)IRSH,GP,IPWS
	ENDDO
1010	FORMAT(1X,'Reciprocal lattice vectors generated ======>',I3)
1020    FORMAT(1X,'    {q+G}x       {q+G}y       {q+G}z         |q+G|',
     &  8X,'DeG')
1030    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,')',2X,G12.5,2X,I4)
1040	FORMAT(1X,'Calculation of shells in reciprocal lattice:')
1050	FORMAT(1X,I2,'th: |G| = ',G14.7,' ; # of vectors = ',I3)
C  CHECK DROFILES
        DO MY=-1,2
        DO IGPTB=0,NGPTB
        IF(NITER(IGPTB,MY).NE.0)THEN
        INQUIRE(FILE=DROFILE(IGPTB,MY),EXIST=EXIST)
        IF(.NOT.EXIST.AND.(MODE.EQ.2.OR.MODE.EQ.3))THEN
        CALL DROFILES(IGPTB,MY,IQPNT,32,'I')
        ENDIF
        INQUIRE(FILE=DPSFILE(IGPTB,MY),EXIST=EXIST)
        IF(.NOT.EXIST.AND.(MODE.EQ.2.OR.MODE.EQ.3))THEN
        CALL DPSFILES(IGPTB,MY,IQPNT,34,'I')
        ENDIF
        ENDIF
        ENDDO
        ENDDO
        RETURN
        END
