        SUBROUTINE DPSIVEC(IGPTB,MY,IPNT,ISGQ,IPAN,IQPNT)
****************************************************************
*  Calculates Fourier transform for pseudowavefunctions.       *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),NDIV(3)
     &   ,IG0IG1(KMAX,NOPRMAX),IK0IK1(KMAX,NOPRMAX),MVECR(3)
     &   ,ILSV(NSORTMAX),NKAP(NPANMAX),ISG(NOPRMAX,NOPRMAX)
     &   ,NDIW(3),IKOV(NOPRMAX)
	COMPLEX*16 EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
     &    ,CFTR(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX)
     &    ,YLM(LIMLMB,0:NBASMAX),CHIK(0:NBASMAX),EXPK(0:NBASMAX)
     &    ,APHK(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,APJK(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,APHQ(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,APJQ(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,PSIK(0:NBASMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,PSIQ(0:NBASMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,U(NWIGMAX,48)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,PNT(3,KMAX),PNTR(3),ORTH(2:3),SH(3,NPANMAX),QPNT(3)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTQ(3)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTK(3)
     &    ,RBAS(3,3),GBAS(3,3)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
        COMMON /ORBS/   NORBS                                !!! from init
        COMMON /SPIN/   NSPIN                                !!! from init
C Inputs:
	COMMON /LATTICE/RBAS,GBAS                            !!! from init
	COMMON /BASIS/  TAU                                  !!! from init
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN                          !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
        COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
C Group:
        COMMON /INVERS/ INV,IKOV                             !!! from group
        COMMON /GROUPOUT/NGROUP,U                            !!! from group
        COMMON /SUBGROUP/NSGQ,NGEQ,ISG                       !!! from symmsh
C K-mesh:
	COMMON /INTTR/  NDIV,NDIW,SH                         !!! from init
	COMMON /MESH/   NPNT,PNT                             !!! from init
	COMMON /QMESH/  NQPNT,QPNT                           !!! from qvector
        COMMON /SYMMESH/IG0IG1,IK0IK1                        !!! from symmsh
C Temporary:
	COMMON /DENS/   PNTR,CFTR,YLM                        !!! from ftrmat
        COMMON /DELRO/  PSIK,PSIQ,PNTK,PNTQ                  !!! from psivec
C Bands:
        COMMON /EIGVEC/ APHK,APJK,APHQ,APJQ                  !!! from lmtvec 
C Plane waves:
	COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from init
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
C Outputs:
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
C  SET POINT-GROUP INFORMATION
        IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
        IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
        IPNTK=IPNT            !!!  point   "k"
        IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
        IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
        IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  ROTATE K-VECTOR BY SYMMETRY OPERATION
        CALL ROTATE(PNT(1,IPNTK),PNT(2,IPNTK),PNT(3,IPNTK),
     &  XK,YK,ZK,U(2,IGK),2)
C  FIND K-POINT R=K+G WHICH HAS A MINIMAL LENGTH
        XK=XK+SH(1,IPAN)
        YK=YK+SH(2,IPAN)
        ZK=ZK+SH(3,IPAN)
        CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &  GRX,GRY,GRZ)
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
        CALL FTRMAT(PNTK,0,IPAN)
C  SET |PSI(k+G)> and D|PSI(k+G)> 
        IF(MODE.NE.5)IBNDMIN=1
        IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)
        IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
        IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
	DO IBNDS=1,NSPIN                               !!! over spin subbands
	DO IORBS=1,NORBS                               !!! over spinors
        DO IBNDT=IBNDMIN,IBNDMAX                       !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
        DO IBAS=0,MIN(NBAS,MBAS)
        PSIK(IBAS,IORBS,IBAND)=(0.D0,0.D0)
	ENDDO
        DO IATOM=1,NATOM                               !!! over iatom
        ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
        DO IBAS=0,MIN(NBAS,MBAS)
        SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
        EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
C  PSEUDOWAVEFUNCTION AND ITS RIGID CHANGE TO FIRST ORDER
        DO IKAP=1,NKAP(IPAN)                           !!! over energies
        DO L=0,ILSB(ISORT)                             !!! over l
        IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
        DO M=-L,L                                      !!! over m
        LM=L*(L+1)+M+1
        DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN)
        PSIK(IBAS,IORBS,IBAND)=PSIK(IBAS,IORBS,IBAND)+
     &  APHK(LM,IATOM,IKAP,IORBS,IBAND)*
     &  CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
	ENDDO
        ENDDO                                          !!! over m
	ENDIF
        ENDDO                                          !!! over l
        ENDDO                                          !!! over ikap
        ENDDO                                          !!! over iatom
        ENDDO                                          !!! over bands
        ENDDO                                          !!! over spinors
	ENDDO                                          !!! over spin subbands
        PNTQ(1)=PNTK(1)+QPNT(1)
        PNTQ(2)=PNTK(2)+QPNT(2)
        PNTQ(3)=PNTK(3)+QPNT(3)
        CALL FTRMAT(PNTQ,0,IPAN)
C  SET |PSI(k+q+G)>
        IF(MODE.NE.5)IBNDMIN=1
        IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)
        IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
        IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
	DO IBNDS=1,NSPIN                               !!! over spin subbands
	DO IORBS=1,NORBS                               !!! over spinors
        DO IBNDT=IBNDMIN,IBNDMAX                       !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
        DO IBAS=0,MIN(NBAS,MBAS)
        PSIQ(IBAS,IORBS,IBAND)=(0.D0,0.D0)
	ENDDO 
        DO IATOM=1,NATOM                               !!! over iatom
        ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
        DO IBAS=0,MIN(NBAS,MBAS)
        SCP=(GPLW(1,IBAS)+PNTQ(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+PNTQ(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+PNTQ(3))*TAU(3,IATOM)
        EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
C  PSEUDOWAVEFUNCTION AND ITS RIGID CHANGE TO FIRST ORDER
        DO IKAP=1,NKAP(IPAN)                           !!! over energies
        DO L=0,ILSB(ISORT)                             !!! over l
        IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
        DO M=-L,L                                      !!! over m
        LM=L*(L+1)+M+1
        DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN)
        PSIQ(IBAS,IORBS,IBAND)=PSIQ(IBAS,IORBS,IBAND)+
     &  APHQ(LM,IATOM,IKAP,IORBS,IBAND)*
     &  CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
	ENDDO
        ENDDO                                          !!! over m
	ENDIF
        ENDDO                                          !!! over l
        ENDDO                                          !!! over ikap
        ENDDO                                          !!! over iatom
        ENDDO                                          !!! over bands
        ENDDO                                          !!! over spinors
	ENDDO                                          !!! over spin subbands
	END
