	SUBROUTINE SPLDPS(IQPNT)
**************************************************************
*  Set new induced density if # of plane waves is changed.   *
**************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NITER(0:NENVMAX,-1:2)
        DIMENSION SMT(NSORTMAX),QPNT(3),ORTH(2:3),ORTH0(2:3)
     &   ,GPLW(3,0:NPLWMAX),GPLW0(3,0:NPLWMAX),RBAS(3,3),GBAS(3,3)
     &   ,RBAS0(3,3),GBAS0(3,3),GPTB(3,0:NENVMAX)
        COMPLEX*16
     &     DRHOPS(0:NPLWMAX,NSPINMAX),TRHOPS(0:NPLWMAX)
     &    ,DMAGPS(0:NPLWMAX,NSPINMAX),TMAGPS(0:NPLWMAX)
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from init
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from readini
        COMMON /SPIN/   NSPIN                                !!! from readini
C Inputs:
        COMMON /MAGCOM/ ITERMAX,NITER                        !!! from readini
        COMMON /POTCOM/ SWZ,SMT                              !!! from readini
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from readini
	COMMON /LATTICE/RBAS,GBAS                            !!! from readstr
        COMMON /QMESH/  NQPNT,QPNT                           !!! from qvector
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB                     !!! from qvector
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
        COMMON /OLDMESH/NPLW0,GPLW0,RBAS0,GBAS0,ORTH0        !!! from dpsfiles
C Density:
        COMMON /DPSRHO/ DRHOPS,DMAGPS                        !!! from dpsfiles
        COMMON /STORE1/ TRHOPS,TMAGPS                        !!! from dpsfiles
C Outputs:
        COMMON /UNIT/   IUN                                  !!! from readini
        COMMON /WORD/   NVAL                                 !!! from setup
        COMMON /TXTEL/  TXTEL                                !!! from readini
        DATA PI/3.141592653589793D0/
	IF(MODE.NE.3)RETURN
C  *** DO GLOBALLY OVER POLARIZATIONS AND DISPLACEMENTS ***
        DO 2000 MY=-1,2                            !!! over polarizations
        DO 1000 IGPTB=0,NGPTB                      !!! over g-vectors
	IF(NITER(IGPTB,MY).EQ.0)GOTO1000
C  READ CHANGE IN CHARGE DENSITY
	CALL DPSFILES(IGPTB,MY,IQPNT,34,'R')
	DO ISPIN=1,NSPIN                           !!! over spins
	ITRAN=ISPIN
C  NEW CHANGE IN PSEUDOCHARGE DENSITY 
        DO IPLW=0,NPLW0
        TRHOPS(IPLW)=DRHOPS(IPLW,ISPIN)
        TMAGPS(IPLW)=DMAGPS(IPLW,ITRAN)
	ENDDO
        DO IPLW=0,NPLW
        DRHOPS(IPLW,ISPIN)=(0.D0,0.D0)
        DMAGPS(IPLW,ITRAN)=(0.D0,0.D0)
	ENDDO
        NPLWI=-1
        DO IPLW=0,NPLW
C  SET G IN UNITS OF GBAS
        X1=GPLW(1,IPLW)*RBAS(1,1)+GPLW(2,IPLW)*RBAS(2,1)+
     &  GPLW(3,IPLW)*RBAS(3,1)
        X2=GPLW(1,IPLW)*RBAS(1,2)+GPLW(2,IPLW)*RBAS(2,2)+
     &  GPLW(3,IPLW)*RBAS(3,2)
        X3=GPLW(1,IPLW)*RBAS(1,3)+GPLW(2,IPLW)*RBAS(2,3)+
     &  GPLW(3,IPLW)*RBAS(3,3)
        M1=ANINT(X1)
        M2=ANINT(X2)
        M3=ANINT(X3)
        IF(ABS(M1-X1).GE.1.D-05.OR.
     &  ABS(M2-X2).GE.1.D-05.OR.
     &  ABS(M3-X3).GE.1.D-05)STOP'<SPLDPS>:
     &  NEW RECIPROCAL VECTOR COORDINATES ARE NOT INTEGER'
        DO JPLW=0,NPLW0
        X1OLD=GPLW0(1,JPLW)*RBAS0(1,1)+
     &        GPLW0(2,JPLW)*RBAS0(2,1)+
     &        GPLW0(3,JPLW)*RBAS0(3,1)
        X2OLD=GPLW0(1,JPLW)*RBAS0(1,2)+
     &        GPLW0(2,JPLW)*RBAS0(2,2)+
     &        GPLW0(3,JPLW)*RBAS0(3,2)
        X3OLD=GPLW0(1,JPLW)*RBAS0(1,3)+
     &        GPLW0(2,JPLW)*RBAS0(2,3)+
     &        GPLW0(3,JPLW)*RBAS0(3,3)
        M1OLD=ANINT(X1OLD)
        M2OLD=ANINT(X2OLD)
        M3OLD=ANINT(X3OLD)
        IF(M1.EQ.M1OLD.AND.M2.EQ.M2OLD.AND.M3.EQ.M3OLD)THEN
        DRHOPS(IPLW,ISPIN)=TRHOPS(JPLW)
        DMAGPS(IPLW,ITRAN)=TMAGPS(JPLW)
        NPLWI=NPLWI+1
        ENDIF
	ENDDO
	ENDDO
	ENDDO                                     !!! over spins
C  STORE NEW CHANGE IN PSEUDODENSITY
	CALL DPSFILES(IGPTB,MY,IQPNT,34,'W')
1000	CONTINUE                                  !!! over g-vectors
2000	CONTINUE                                  !!! over polarizations
        WRITE(IUN,1010)NPLW0,NPLW,NPLWI
1010    FORMAT(1X,'Plane waves: old=',I7,'; new=',I7,'; coinsiding ',I7)
        END
