	SUBROUTINE SYMDHUB(IQPNT)
***********************************************************
*   Symmetrizes change in the occupation numbers.         *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IKOV(NOPRMAX),NHSORT(NSORTMAX),IS(NPAT),NKAP(NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,IP(NPAT,NOPRMAX),ISG(NOPRMAX,NOPRMAX)
     &   ,INGPTBR(NOPRMAX,0:NENVMAX),INDGPTB(0:NENVMAX)
     &   ,NITER(0:NENVMAX,-1:2)
	COMPLEX*16
     &    DELDHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,SIMDHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,SIMMHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,ATMP1(-LMAXT:LMAXT,-LMAXT:LMAXT,NPAT)
     &   ,TMPARR(-LMAXT:LMAXT),U(NWIGMAX,48),PHSQ
	DIMENSION PNT(3,KMAX),SHIFT(3,NOPRMAX),QPNT(3)
     &   ,RDC(3,NPAT,NOPRMAX),GPTB(3,0:NENVMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
        COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /ORBS/   NORBS                               !!! from init
C Inputs:
        COMMON /MAGCOM/ ITERMAX,NITER                       !!! from qvector
	COMMON /KAPPAR/ NPAN,NKAP                           !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS               !!! from init
        COMMON /QMESH/  NQPNT,QPNT                          !!! from init
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB,INGPTBR    !!! from plwptb
C Occupancies:
        COMMON /DELHUB/ DELDHUB,DELMHUB                     !!! from symdhub
C Group:
	COMMON /INVERS/ INV,IKOV                            !!! from group
	COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT              !!! from group
        COMMON /SUBGROUP/NSGQ,NGEQ,ISG                      !!! from symmsh
C Outputs:
	COMMON /WORD/   NVAL                                !!! from nmtdat
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
	IF(MODE.EQ.5)RETURN
        DO 3000 MY=-1,2                                !!! over polarizations
        DO 2000 IGPTB=0,NGPTB                          !!! over g-vectors
        IF(NITER(IGPTB,MY).EQ.0)GOTO2000
C  SET SYMMETRIZED CHARGE DENSITY TO ZERO.
        DO ISPIN=1,NSPIN
        ITRAN=ISPIN
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        DO L=0,ILSB(ISORT)
        DO M =-L,L
        LM=L*(L+1)+M+1
        DO K=-L,L 
        LM=L*(L+1)+M+1
        LK=L*(L+1)+K+1
        IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	SIMDHUB(IU,IATOM,ISPIN,IGPTB,MY)=(0.D0,0.D0)
	SIMMHUB(IU,IATOM,ITRAN,IGPTB,MY)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
C  DO OVER GROUP OF WAVE VECTOR Q
        DO 1000 IGEQ=1,NGEQ                           !!! over group of q-vector
        IR=ISG(IGEQ,1)                                !!! element "g" in the main G-list
        IG=IKOV(IR)                                   !!! element "g" after Kovalev
        IGPTBR=INGPTBR(IGEQ,IGPTB)                    !!! q+Gr=q+gamma^{-1}G
C  DO OVER SPINS AND ATOMS
        DO 200 ISPIN=1,NSPIN                          !!! over spins
        ITRAN=ISPIN
        DO 100 IATOM=1,NATOM                          !!! over atoms
        ISORT=IS(IATOM)
        IATOMG=IP(IATOM,IR)
        IF(IS(IATOMG).NE.ISORT)STOP'<SYMDHUB>:: ERROR IN IP-ARRAY'
        SQ=(QPNT(1)+GPTB(1,IGPTB))*(RDC(1,IATOM,IR)+SHIFT(1,IR))+
     &     (QPNT(2)+GPTB(2,IGPTB))*(RDC(2,IATOM,IR)+SHIFT(2,IR))+
     &     (QPNT(3)+GPTB(3,IGPTB))*(RDC(3,IATOM,IR)+SHIFT(3,IR))
        PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
        DO L=0,ILSB(ISORT)
	NLS=L*(2*L-1)*(2*L+1)/3
	DO M1=-L,L
	DO M=-L,L
	IU10=NLS+(2*L+1)*(L+M)+L+M1+1
	DO M2=-L,L
	IWIG12=NLS+(2*L+1)*(L+M2)+L+M1+1
	DO M3=-L,L
	IWIG03=NLS+(2*L+1)*(L+M3)+L+M+1
	IU23=NLS+(2*L+1)*(L+M3)+L+M2+1
        SIMDHUB(IU10,IATOM,ISPIN,IGPTB,MY)=
     &  SIMDHUB(IU10,IATOM,ISPIN,IGPTB,MY)+
     &  U(IWIG03,IG)*PHSQ*CONJG(U(IWIG12,IG))*
     &  DELDHUB(IU23,IP(IATOM,IR),ISPIN,IGPTBR,MY)
        SIMMHUB(IU10,IATOM,ISPIN,IGPTB,MY)=
     &  SIMMHUB(IU10,IATOM,ISPIN,IGPTB,MY)+
     &  U(IWIG03,IG)*PHSQ*CONJG(U(IWIG12,IG))*
     &  DELMHUB(IU23,IP(IATOM,IR),ISPIN,IGPTBR,MY)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
 100    CONTINUE                                       !!! over atoms in cell
 200    CONTINUE                                       !!! over spins
1000    CONTINUE                                       !!! over group
2000    CONTINUE                                       !!! over g-vectors
3000    CONTINUE                                       !!! over polarizations
C NORMALIZATION
        DO MY=-1,2                                     !!! over polarizations
        DO IGPTB=0,NGPTB                               !!! over g-vectors
        IF(NITER(IGPTB,MY).EQ.0)CYCLE
        DO ISPIN=1,NSPIN
        ITRAN=ISPIN
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        DO L=0,ILSB(ISORT)
        DO M =-L,L
        LM=L*(L+1)+M+1
        DO K=-L,L
        LM=L*(L+1)+M+1
        LK=L*(L+1)+K+1
        IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
        DELDHUB(IU,IATOM,ISPIN,IGPTB,MY)=
     &  SIMDHUB(IU,IATOM,ISPIN,IGPTB,MY)/DBLE(NGEQ)
        DELMHUB(IU,IATOM,ITRAN,IGPTB,MY)=
     &  SIMMHUB(IU,IATOM,ITRAN,IGPTB,MY)/DBLE(NGEQ)
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        RETURN
	END
