	SUBROUTINE SYMDRHO(IQPNT)
********************************************************
*  Symmetrizes change in charge density.               *
********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IKOV(NOPRMAX),IP(NPAT,NOPRMAX),NITER(0:NENVMAX,-1:2)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NRAD(NSORTMAX),NQDIV(3)
     &   ,ISG(NOPRMAX,NOPRMAX),INDGPTB(0:NENVMAX)
     &   ,INGPTBR(NOPRMAX,0:NENVMAX)
	COMPLEX*16 U(NWIGMAX,48),PHSQ
     &    ,DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &    ,DMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &    ,SRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &    ,SMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
	DIMENSION QPNT(3),QPNT0(3),SMT(NSORTMAX),H(NSORTMAX)
     &   ,RDC(3,NPAT,NOPRMAX),R(0:NRADMAX,NSORTMAX)
     &   ,GPTB(3,0:NENVMAX),SHIFT(3,NOPRMAX)
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
        COMMON /SPIN/   NSPIN                               !!! from readini
C Inputs:
	COMMON /MAGCOM/ ITERMAX,NITER                       !!! from qvector
        COMMON /QMESH/  NQPNT,QPNT,NUMQ,NQDIV,KEYQ          !!! from qvector
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB,INGPTBR    !!! from plwptb
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
	COMMON /RADMESH/NRAD,H,R                            !!! from radmsh
C Group:
        COMMON /INVERS/ INV,IKOV                            !!! from group
        COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT              !!! from group
        COMMON /SUBGROUP/NSGQ,NGEQ,ISG                      !!! from symmsh
C Density:
        COMMON /DELRO/  DRHO,DMAG                           !!! from delro
        COMMON /DELPOT/ SRHO,SMAG                           !!! from delro
C Outputs:
	COMMON /UNIT/   IUN                                 !!! from readini
        DATA PI/3.141592653589793D0/
	IF(MODE.EQ.5)RETURN
	DO 3000 MY=-1,2                                !!! over polarizations
	DO 2000 IGPTB=0,NGPTB                          !!! over g-vectors
	IF(NITER(IGPTB,MY).EQ.0)GOTO2000
        CALL DROFILES(IGPTB,MY,IQPNT,30,'I')           !!! initialize file
C  SET SYMMETRIZED CHARGE DENSITY TO ZERO. 
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN
	ITRAN=ISPIN
        DO L=0,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        DO IRAD=0,NRAD(ISORT)
        SRHO(IRAD,LM,IATOM,ISPIN)=(0.D0,0.D0)
        SMAG(IRAD,LM,IATOM,ITRAN)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
C  DO OVER GROUP OF WAVE VECTOR Q
        DO 1000 IGEQ=1,NGEQ                           !!! over group of q-vector
        IR=ISG(IGEQ,1)                                !!! element "g" in the main G-list
        IG=IKOV(IR)                                   !!! element "g" after Kovalev
        IGPTBR=INGPTBR(IGEQ,IGPTB)                    !!! q+Gr=q+gamma^{-1}G
	CALL DROFILES(IGPTBR,MY,IQPNT,33,'R')
C  DO OVER SPINS AND ATOMS
	DO ISPIN=1,NSPIN                              !!! over spins  
	ITRAN=ISPIN
	DO IATOM=1,NATOM                              !!! over atoms
        ISORT=IS(IATOM)
        IATOMG=IP(IATOM,IR)
        IF(IS(IATOMG).NE.ISORT)STOP'<SYMDRHO>:: ERROR IN IP-ARRAY'
        PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
        SQ=(QPNT(1)+GPTB(1,IGPTB))*(RDC(1,IATOM,IR)+SHIFT(1,IR))+
     &     (QPNT(2)+GPTB(2,IGPTB))*(RDC(2,IATOM,IR)+SHIFT(2,IR))+
     &     (QPNT(3)+GPTB(3,IGPTB))*(RDC(3,IATOM,IR)+SHIFT(3,IR))
        PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
        DO L=0,ILSV(ISORT)                            !!! over l
        LL=L*(2*L-1)*(2*L+1)/3
        DO M=-L,L                                     !!! over m
        LM=L*(L+1)+M+1
C  SYMMETRIZATION
	DO M1=-L,L                                    !!! over m1
	LM1=L*(L+1)+M1+1
	IWIG01=LL+(2*L+1)*(L+M1)+L+M+1                !!! U(l,m,m1)
	DO IRAD=0,NRAD(ISORT)
	SRHO(IRAD,LM,IATOM,ISPIN)=SRHO(IRAD,LM,IATOM,ISPIN)+
     &  U(IWIG01,IG)*DRHO(IRAD,LM1,IATOMG,ISPIN)*PHSQ
	SMAG(IRAD,LM,IATOM,ITRAN)=SMAG(IRAD,LM,IATOM,ITRAN)+
     &  U(IWIG01,IG)*DMAG(IRAD,LM1,IATOMG,ITRAN)*PHSQ
	ENDDO
        ENDDO                                         !!! over m1
        ENDDO                                         !!! over m
        ENDDO                                         !!! over l
        ENDDO                                         !!! over atoms
        ENDDO                                         !!! over spins
1000	CONTINUE                                      !!! over group of q-vector
C  SYMMETRIZATION FINISHED, NORMALIZATION
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN
	ITRAN=ISPIN
        DO L=0,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        DO IRAD=0,NRAD(ISORT)
	DRHO(IRAD,LM,IATOM,ISPIN)=SRHO(IRAD,LM,IATOM,ISPIN)/
     &  DBLE(NGEQ)
	DMAG(IRAD,LM,IATOM,ITRAN)=SMAG(IRAD,LM,IATOM,ITRAN)/
     &  DBLE(NGEQ)
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
C  SAVE FINAL CHANGE IN CHARGE DENSITY
	CALL DROFILES(IGPTB,MY,IQPNT,30,'W')
2000	CONTINUE                                      !!! over g-vectors
	DO IGPTB=0,NGPTB
	IF(NITER(IGPTB,MY).NE.0)THEN
	CALL DROFILES(IGPTB,MY,IQPNT,30,'R')
	CALL DROFILES(IGPTB,MY,IQPNT,33,'W')
	CALL DROFILES(IGPTB,MY,IQPNT,30,'D')
	ENDIF
	ENDDO
3000	CONTINUE                                      !!! over polarizations
	END
