	SUBROUTINE TTRVEL(EF0,DOS,VEL,SPDOS,SPVEL)
***********************************************************
*  The calculation of the mean square velocities at EF.   *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NHSORT(NSORTMAX),IS(NPAT),NDIV(3),KTT(4)
     &   ,ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,KCUT(3,4,6),KCUW(3,4,6),IPQ(0:50,0:50,0:50)
     &   ,IGQ(0:50,0:50,0:50),IPW(0:50,0:50,0:50)
     &   ,IGW(0:50,0:50,0:50),NDIW(3),KTW(4)
	DIMENSION PNT(3,KMAX),PNW(3,KMAX)
     &   ,EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,EARW(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,WEIGH(NDIMMAX*NSPINMAX,KMAX),E(4),REC(3,3)
     &   ,WEIGD(NDIMMAX*NSPINMAX,KMAX),AT(4),AD(4)
     &   ,SPDOS(NSPINMAX),SPTOS(NSPINMAX),SPVEL(3,NSPINMAX)
     &   ,ORTH(2:3),RBAS(3,3),GBAS(3,3),QB(3,3)
     &   ,RB(3,3),QW(3,3),RW(3,3),PKT(3,4),PKW(3,4),CRW(3,4)
     &   ,VEL(3),VK(3)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT    !!! from init
        COMMON /LATTICE/RBAS,GBAS,QB,RB,QW,RW                   !!! from init
	COMMON /MESH/   NPNT,PNT                                !!! from ttrmsh
	COMMON /MESW/   NPNW,PNW                                !!! from ttrmsh
        COMMON /WMESH/  KCUT,IPQ,IGQ                            !!! from bzmesh
        COMMON /WMESW/  KCUW,IPW,IGW                            !!! from bzmesh
	COMMON /ENERGY/ EARR,WEIGH,WEIGD                        !!! from lmtbnd
        COMMON /ENRWGT/ EARW                                    !!! from lmtbnd
	COMMON /KAPPAR/ NPAN                                    !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                       !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                         !!! from init
	COMMON /SPIN/   NSPIN                                   !!! from init
	COMMON /ORBS/   NORBS                                   !!! from init
	COMMON /INTTR/  NDIV,NDIW                               !!! from init
	COMMON /UNIT/   IUN                                     !!! from init
	DATA PI/3.141592653589793D0/,EPS/1.D-10/
C *********** INITIALIZATION **************
        EF=EF0
        DO IBNDS=1,NSPIN
        SPTOS(IBNDS)=0.D0
        SPDOS(IBNDS)=0.D0
        SPVEL(1,IBNDS)=0.D0
        SPVEL(2,IBNDS)=0.D0
        SPVEL(3,IBNDS)=0.D0
        ENDDO
	VOLIBZ=1.D0
	OT=1.D0/NDIV(1)/NDIV(2)/NDIV(3)/6.D0
	OW=1.D0/NDIW(1)/NDIW(2)/NDIW(3)/6.D0
C *********** TETRAHEDRON METHOD **********
C  DO OVER MICROCELLS
        DO 2200 I3=0,NDIV(3)-1               !!! over cells along G3
        DO 2200 I2=0,NDIV(2)-1               !!! over cells along G2
        DO 2200 I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRON INSIDE MICROCELL
        DO 2100 ITTR=1,6                     !!! over tetrahedra
        DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT
        J1=I1+KCUT(1,I,ITTR)
        J2=I2+KCUT(2,I,ITTR)
        J3=I3+KCUT(3,I,ITTR)
        KTT(I)=IPQ(J1,J2,J3)
	ENDDO
C  SET UP POINTS "K" DESCRIBING TETRAHEDRON IN THE SPACE
        DO I=1,4
        J1=I1+KCUT(1,I,ITTR)
        J2=I2+KCUT(2,I,ITTR)
        J3=I3+KCUT(3,I,ITTR)
        PKT(1,I)=(J1*QB(1,1)+J2*QB(1,2)+J3*QB(1,3))*2.D0*PI/PAR
        PKT(2,I)=(J1*QB(2,1)+J2*QB(2,2)+J3*QB(2,3))*2.D0*PI/PAR
        PKT(3,I)=(J1*QB(3,1)+J2*QB(3,2)+J3*QB(3,3))*2.D0*PI/PAR
	ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
	DO I=2,4
	PKT(1,I)=PKT(1,I)-PKT(1,1)
	PKT(2,I)=PKT(2,I)-PKT(2,1)
	PKT(3,I)=PKT(3,I)-PKT(3,1)
	ENDDO
C  SET RECIPROCALS "REC" TO "PKT"
        CALL CROSS(REC(1,1),PKT(1,3),PKT(1,4))
        CALL CROSS(REC(1,2),PKT(1,4),PKT(1,2))
        CALL CROSS(REC(1,3),PKT(1,2),PKT(1,3))
        W=REC(1,1)*PKT(1,2)+REC(2,1)*PKT(2,2)+REC(3,1)*PKT(3,2)
	IF(ABS(W).LE.1.D-10)STOP'<TTRINT1>:: INTERNAL ERROR: W=0'
        DO I=1,3
        REC(I,1)=REC(I,1)/W
        REC(I,2)=REC(I,2)/W
        REC(I,3)=REC(I,3)/W
	ENDDO
C  DO OVER DIVISIONS OF THE MICROCELL
	DO 400 ID3=0,NDIW(3)/NDIV(3)-1
	DO 400 ID2=0,NDIW(2)/NDIV(2)-1
	DO 400 ID1=0,NDIW(1)/NDIV(1)-1
C  THE SMALL MICROCELL IS SET UP BY IW1,IW2,IW3
	IW1=I1*NDIW(1)/NDIV(1)+ID1
	IW2=I2*NDIW(2)/NDIV(2)+ID2
	IW3=I3*NDIW(3)/NDIV(3)+ID3
C  SET UP SMALL TETRAHEDRON INSIDE SMALL MICROCELL
	DO 300 ITTRD=1,6
	DO I=1,4
        JW1=IW1+KCUT(1,I,ITTRD)
        JW2=IW2+KCUT(2,I,ITTRD)
        JW3=IW3+KCUT(3,I,ITTRD)
        KTW(I)=IPW(JW1,JW2,JW3)
	ENDDO
C  SET UP POINTS K DESCRIBING SMALL TETRAHEDRON IN THE SPACE
        DO I=1,4
        JW1=IW1+KCUT(1,I,ITTRD)
        JW2=IW2+KCUT(2,I,ITTRD)
        JW3=IW3+KCUT(3,I,ITTRD)
        PKW(1,I)=(JW1*QW(1,1)+JW2*QW(1,2)+JW3*QW(1,3))*2.D0*PI/PAR
        PKW(2,I)=(JW1*QW(2,1)+JW2*QW(2,2)+JW3*QW(2,3))*2.D0*PI/PAR
        PKW(3,I)=(JW1*QW(3,1)+JW2*QW(3,2)+JW3*QW(3,3))*2.D0*PI/PAR
	ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
	DO I=1,4
	PKW(1,I)=PKW(1,I)-PKT(1,1)
	PKW(2,I)=PKW(2,I)-PKT(2,1)
	PKW(3,I)=PKW(3,I)-PKT(3,1)
	ENDDO
C  CHECK WHETHER A SMALL TETRAHEDRON "PKW" IS INSIDE  TETRAHEDRON "PKT"
	DO I=1,4
        X1=PKW(1,I)*REC(1,1)+PKW(2,I)*REC(2,1)+PKW(3,I)*REC(3,1)
        X2=PKW(1,I)*REC(1,2)+PKW(2,I)*REC(2,2)+PKW(3,I)*REC(3,2)
        X3=PKW(1,I)*REC(1,3)+PKW(2,I)*REC(2,3)+PKW(3,I)*REC(3,3)
	IF(.NOT.((X1.GE.-EPS.AND.X1.LE.1.D0+EPS).AND.
     &	         (X2.GE.-EPS.AND.X2.LE.1.D0+EPS).AND.
     &	         (X3.GE.-EPS.AND.X3.LE.1.D0+EPS).AND.
     &           (X1+X2+X3.LE.1.D0+EPS)))GOTO300
	CRW(1,I)=X1
	CRW(2,I)=X2
	CRW(3,I)=X3
	ENDDO
C  CALCULATE CONTRIBUTION TO THE POINTS GIVEN BY "KTT=PKT"
        DO 200 IBNDS=1,NSPIN                   !!! over spin subbands
        DO 100 IBNDT=1,NBNDT(1)                !!! over valence bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO I=1,4
	IPNT=KTW(I)
	E(I)=EARW(IBAND,IPNT,1)
	ENDDO
        CALL GETVEL(E,PKW,VK)                  !!! dE(kj)/dk
	CALL MCTTRINT0(E,EF,OW,AT,AD,TS,DS,'B','W')
        SPTOS(IBNDS)=SPTOS(IBNDS)+TS
        SPDOS(IBNDS)=SPDOS(IBNDS)+DS
        DO IVEL=1,3                            !!! velocities
        SPVEL(IVEL,IBNDS)=SPVEL(IVEL,IBNDS)+DS*VK(IVEL)**2
        ENDDO
 100    CONTINUE                               !!! over valence bands
 200    CONTINUE                               !!! over spin subbands
 300	CONTINUE                               !!! over small tetrahedra
 400	CONTINUE                               !!! over small microcells
2100	CONTINUE                               !!! over tetrahedra
2200	CONTINUE                               !!! over microcells
C ************ END OF INTEGRATION ***********
C  NORMALIZATION
        DO IBNDS=1,NSPIN
        SPTOS(IBNDS)=SPTOS(IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)!!! tos
        SPDOS(IBNDS)=SPDOS(IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)!!! dos
        SPVEL(1,IBNDS)=SPVEL(1,IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)! <v_x^2>
        SPVEL(2,IBNDS)=SPVEL(2,IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)! <v_y^2>
        SPVEL(3,IBNDS)=SPVEL(3,IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)! <v_z^2>
        ENDDO
        TOS=(SPTOS(1)+SPTOS(NSPIN))/2.D0*DBLE(NSPIN)
        DOS=(SPDOS(1)+SPDOS(NSPIN))/2.D0*DBLE(NSPIN)
        VEL(1)=(SPVEL(1,1)+SPVEL(1,NSPIN))/2.D0*DBLE(NSPIN)
        VEL(2)=(SPVEL(2,1)+SPVEL(2,NSPIN))/2.D0*DBLE(NSPIN)
        VEL(3)=(SPVEL(3,1)+SPVEL(3,NSPIN))/2.D0*DBLE(NSPIN)
C  PRINT DOS
        WRITE(IUN,1010)EF,TOS,DOS
1010    FORMAT(' EF,TOS,DOS==',3(1X,G14.7))
        IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
        WRITE(IUN,1020)SPTOS(1)    ,SPDOS(1)
        WRITE(IUN,1030)SPTOS(NSPIN),SPDOS(NSPIN)
        WRITE(IUN,1040)SPTOS(1)-SPTOS(NSPIN)
1020    FORMAT('    TUP,DUP==',15X,2(1X,G14.7))
1030    FORMAT('    TDN,DDN==',15X,2(1X,G14.7))
1040    FORMAT(' MM=TUP-TDN==',15X,1X,G14.7)
        ENDIF
C  PRINT VELOCITIES
        WRITE(IUN,1050)
1050    FORMAT(1X,'Calculated average square of electron velocities:')
        WRITE(IUN,1060)(VEL(I),I=1,3)
        IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
        WRITE(IUN,1070)(SPVEL(I,1),I=1,3)
        WRITE(IUN,1080)(SPVEL(I,NSPIN),I=1,3)
1060    FORMAT(1X,'<Vx^2>=',G14.7,' ; <Vy^2>=',G14.7,' ; <Vz^2>=',G14.7)
1070    FORMAT(1X,'<Ux^2>=',G14.7,' ; <Uy^2>=',G14.7,' ; <Uz^2>=',G14.7)
1080    FORMAT(1X,'<Dx^2>=',G14.7,' ; <Dy^2>=',G14.7,' ; <Dz^2>=',G14.7)
        ENDIF
C  PRINT PLASMA FREQUENCIES
        WRITE(IUN,1090)
1090    FORMAT(1X,'Calculated bare plasma frequencies (in eV):')
        WRITE(IUN,1100)(13.6058D0*SQRT(8.D0*PI*VEL(I)/OMEGAC),I=1,3)
        IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
        WRITE(IUN,1110)(13.6058D0*
     &  SQRT(8.D0*PI*SPVEL(I,1)/OMEGAC),I=1,3)
        WRITE(IUN,1120)(13.6058D0*
     &  SQRT(8.D0*PI*SPVEL(I,NSPIN)/OMEGAC),I=1,3)
1100    FORMAT(1X,'om_p^x=',G14.7,' ; om_p^y=',G14.7,' ; om_p^z=',G14.7)
1110    FORMAT(1X,'om_u^x=',G14.7,' ; om_u^y=',G14.7,' ; om_u^z=',G14.7)
1120    FORMAT(1X,'om_d^x=',G14.7,' ; om_d^y=',G14.7,' ; om_d^z=',G14.7)
        ENDIF
        RETURN
        END

        SUBROUTINE GETVEL(E0,Q0,V)
*************************************************
*  Calculates velocities inside the tetrahedron *
*************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION E0(4),Q0(3,4),V(3),Q(3,3),EV(3)
        DO J=1,3
        EV(J)=E0(J)-E0(4)
        DO I=1,3
        Q(J,I)=Q0(I,J)-Q0(I,4)
        ENDDO
        ENDDO
        CALL SIMQ(Q,EV,3,3,IFAIL)
        IF(IFAIL.NE.0)PRINT*,'<GETVEL>: SIMQ FAILS'
        DO IV=1,3
        V(IV)=EV(IV)
        ENDDO
        END

