	SUBROUTINE VCOUL
************************************************************
*  The calculation of the Coulomb potential within MTS     *
*  without nuclear part.                                   * 
*  Written by S.Yu.Savrasov (P.N.Lebedev Physical Instit.) *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT),NRAD(NSORTMAX)
     &    ,ISPL(NSORTMAX)
	COMPLEX*16 VC1(0:NRADMAX),VC2(0:NRADMAX),CMAD
     &    ,AMTOT(NSYMMAX,NPAT,NSPINMAX),PSMOM(NSYMMAX,NPAT,NSPINMAX)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &    ,PSMOM1(NSYMMAX,NPAT,NSPINMAX)
     &    ,QMAD(2,NSYMMAX,NPAT,NSPINMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),SPLIT(NSORTMAX)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,SMT(NSORTMAX),RL(0:NRADMAX,0:LMAXV,NSORTMAX)
     &    ,ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX)
     &    ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX)
     &    ,Z(NSORTMAX),ZCOR(NSORTMAX)
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                      !!! from vcoul
	COMMON /DENS/   RO,ROVALDS,ROCOR                    !!! from rofull
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from init
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symmlm
	COMMON /MULTRO/ Z,ZCOR,AMTOT,PSMOM,PSMOM1,QMAD      !!! from multro
	COMMON /SPIN/   NSPIN,SPLIT,ISPL                    !!! from init
	COMMON /EXCH/   IXC                                 !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C  **** CALCULATE COULOMB CONTRIBUTION TO THE POTENTIAL **** 
	DO 90 IATOM=1,NATOM                 !!! over all atoms in cell
	ISORT=IS(IATOM)
	DO 80 ISPIN=1,NSPIN                 !!! over spins
C  DO OVER SPHERICAL HARMONICS EXPANSIONS
	DO 70 L=0,ILSV(ISORT)               !!! over l
	DO 60 M=-L,L                        !!! over m
	LM=L*(L+1)+M+1
	ISYM=LMSYM(LM,IATOM)
	SL=SMT(ISORT)**L
	IF(SYM(LM,IATOM))THEN               !!! for only non-zero components
	DO 10 IRAD=0,NRAD(ISORT)            !!! over radial mesh
	V(IRAD,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
  10    CONTINUE                            !!! over radial mesh
C   COULOMB CONTRIBUTION  (EXTERNAL PART FROM MTS)
	CMAD=(QMAD(1,ISYM,IATOM,1)+QMAD(1,ISYM,IATOM,NSPIN)+
     &  QMAD(2,ISYM,IATOM,1)+QMAD(2,ISYM,IATOM,NSPIN))/2.D0*DBLE(NSPIN)
	DO 30 IRAD=0,NRAD(ISORT)            !!! over radial mesh
	V(IRAD,ISYM,IATOM,ISPIN)=V(IRAD,ISYM,IATOM,ISPIN)+
     &  2.D0*CMAD*RL(IRAD,L,ISORT)/SL
  30    CONTINUE                            !!! over radial mesh
C   COULOMB CONTRIBUTION  (INTERNAL PART FROM CHARGE DENSITY)
	CALL POISS1(VC1,VC2,L,ISYM,IATOM)   !!! solve the Poisson equation
	PL=2.D0/(2.D0*L+1.D0)
	DO 40 IRAD=0,NRAD(ISORT)            !!! over radial mesh
	V(IRAD,ISYM,IATOM,ISPIN)=V(IRAD,ISYM,IATOM,ISPIN)+
     &  PL*(VC1(IRAD)+VC2(IRAD))
  40    CONTINUE                            !!! over radial mesh
	ENDIF                               !!! for only non-zero components
  60    CONTINUE                            !!! over m
  70    CONTINUE                            !!! over l
  80    CONTINUE                            !!! over spins
  90    CONTINUE                            !!! over all atoms in cell
	END



	SUBROUTINE POISS1(VC1,VC2,L,ISYM,IATOM)
*************************************************************
* The solution of the Poisson equation whithin MT-spheres.  * 
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX),IS(NPAT)
     &   ,NRAD(NSORTMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),ROTOT(0:NRADMAX)
     &   ,WORK2(0:NRADMAX),VC1(0:NRADMAX),VC2(0:NRADMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX),WORK1(0:NRADMAX)
	DIMENSION ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),RL(0:NRADMAX,0:LMAXV,NSORTMAX)
     &   ,DR(0:NRADMAX,NSORTMAX),H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM     !!! from init
	COMMON /DENS/   RO,ROVALDS,ROCOR                  !!! from ro_full
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL             !!! from radmsh
	COMMON /SPIN/   NSPIN                             !!! from init
C   INITIATION
	ISORT=IS(IATOM)
	DO 1 IRAD=0,NRAD(ISORT)
	ROTOT(IRAD)=(RO(IRAD,ISYM,IATOM,1)+
     &  RO(IRAD,ISYM,IATOM,NSPIN))/2.D0*DBLE(NSPIN)
    1   CONTINUE
C   SOLUTION OF THE POISSON EQUATION
	DO 10 IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=ROTOT(IRAD)*WEIGHT(IRAD,ISORT)*RL(IRAD,L,ISORT)
  10    CONTINUE
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	VC1(0)=0.0
	DO 20 IRAD=1,NRAD(ISORT)
	VC1(IRAD)=WORK2(IRAD)
	DO 15 L1=1,L+1
	VC1(IRAD)=VC1(IRAD)/R(IRAD,ISORT)
  15    CONTINUE
  20    CONTINUE
	WORK1(0)=0.0
	DO 30 IRAD=1,NRAD(ISORT)
	WORK1(IRAD)=ROTOT(IRAD)*WEIGHT(IRAD,ISORT)
	DO 25 L1=1,L+1
	WORK1(IRAD)=WORK1(IRAD)/R(IRAD,ISORT)
  25    CONTINUE
  30    CONTINUE
	IF(L.LE.1)THEN
	CALL CQD(H(ISORT),WORK1(0),WORK2(0),NRAD(ISORT)+1)
	ELSE
	CALL CQD(H(ISORT),WORK1(2),WORK2(2),NRAD(ISORT)-1)
	WORK2(1)=-(WORK1(1)+WORK1(2))*0.5D0*H(ISORT)
	ENDIF
	VC2(0)=0.0
	DO 40 IRAD=1,NRAD(ISORT)
	VC2(IRAD)=(WORK2(NRAD(ISORT))-WORK2(IRAD))*RL(IRAD,L,ISORT)
  40    CONTINUE
	IF(L.EQ.0)VC2(0)=WORK2(NRAD(ISORT))
	END





	SUBROUTINE DRSUB(FUN,DFUNDR,NRAD,H,R,DR)
****************************************************************
*   Calculates radial derivative.                              *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	DIMENSION R(0:NRADMAX),DR(0:NRADMAX)
	COMPLEX*16 FUN(0:NRADMAX),DFUNDR(0:NRADMAX)
	DATA PI/3.141592653589793D0/
C PARABOLIC INTERPOLATION FORMULA
	F3FUN(X,F1,F2,F3,X1,X2,X3)=
     &  (X-X2)*(X-X3)/(X1-X2)/(X1-X3)*F1+
     &  (X-X1)*(X-X3)/(X2-X1)/(X2-X3)*F2+
     &  (X-X1)*(X-X2)/(X3-X1)/(X3-X2)*F3
C CORRESPONDING FIRST-ORDER DERIVATIVE
	F3DER(X,F1,F2,F3,X1,X2,X3)=
     &  ((X-X2)+(X-X3))/(X1-X2)/(X1-X3)*F1+
     &  ((X-X1)+(X-X3))/(X2-X1)/(X2-X3)*F2+
     &  ((X-X1)+(X-X2))/(X3-X1)/(X3-X2)*F3
	IF(NRAD.LT.7)STOP'<DRSUB> # of rad.points is too small'
C DEFINE MESH PARAMETERS
        BETTA=R(NRAD)/(EXP(H*DBLE(NRAD))-1.D0)
	STEPRAD=1.D0
C GET FIRST-ORDER DERIVATIVE
	DO 10 IRAD=0,NRAD                       !!! over rad.points
	DIRADDR=1.D0/(H*(R(IRAD)+BETTA))
	IF(IRAD.EQ.0)THEN
	DFUNDR(IRAD)=((6.D0*FUN(IRAD+1)+
     &  20.D0/3.D0*FUN(IRAD+3)+
     &  1.2D0*FUN(IRAD+5))-
     &  (2.45D0*FUN(IRAD+0)+7.5D0*
     &  FUN(IRAD+2)+3.75D0*FUN(IRAD+4)+
     &  1.D0/6.D0*FUN(IRAD+6)))/STEPRAD*DIRADDR
	ELSEIF(IRAD.EQ.1)THEN
	DFUNDR(IRAD)=((6.D0*FUN(IRAD+1)+
     &  20.D0/3.D0*FUN(IRAD+3)+
     &  1.2D0*FUN(IRAD+5))-
     &  (2.45D0*FUN(IRAD+0)+7.5D0*
     &  FUN(IRAD+2)+3.75D0*FUN(IRAD+4)+
     &  1.D0/6.D0*FUN(IRAD+6)))/STEPRAD*DIRADDR
	ELSEIF(IRAD.GT.1.AND.IRAD.LT.NRAD-1)THEN
	DFUNDR(IRAD)=(FUN(IRAD-2)-
     &  FUN(IRAD+2)+8.D0*FUN(IRAD+1)-
     &  8.D0*FUN(IRAD-1))/12.D0/
     &  STEPRAD*DIRADDR
	ELSEIF(IRAD.EQ.NRAD-1)THEN
	DFUNDR(IRAD)=(-1.D0/12.D0*
     &  FUN(IRAD-3)+0.5D0*FUN(IRAD-2
     &  )-1.5D0*FUN(IRAD-1)+
     &  5.D0/6.D0*FUN(IRAD)+0.25D0*
     &  FUN(IRAD+1))/STEPRAD*DIRADDR
	ELSEIF(IRAD.EQ.NRAD)THEN
	DFUNDR(IRAD)=(0.25D0*
     &  FUN(IRAD-4)-4.D0/3.D0*FUN(IRAD-3
     &  )+3.D0*FUN(IRAD-2)-
     &  4.D0*FUN(IRAD-1)+25.D0/12.D0*
     &  FUN(IRAD))/STEPRAD*DIRADDR
	ENDIF
  10    CONTINUE                              !!! over rad.points
	END
